// Vertex shader "Anisotropic", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Anisotropic : VShader {
    // Vertex shader "Anisotropic".  Uses 36 float temporaries, 46 float
    // constants, and 84 instructions.
    public Anisotropic() : base(@"
        vs.1.1
        ; c0 = {1.0, 1.5708, 3.14159, 0.5}
        ; c1 = {2.0, 2.4674, 6.08807, 15.0217}
        ; c2 = {0.0, 1.0, 6.28319, 12.5664}
        ; c3 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c4 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c5 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c6, world_2 = c7, world_3 = c8, world_4 = c9, eyePos = c10.xyz, ambient = c3.w, diffuse = c10.w, specular = c11.x, power = c11.y
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, v0.y, c0.w                ; p_0 = v + c_0.w
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.z, r0.y, -c0.y         ; a = c_0.z * p_1.y - c_0.y
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.y, c4, r2                    ; f = c_4 <.> p_1
        dp4 r0.z, c5, r1                    ; e = c_5 <.> d
        mul r0.w, v0.x, v0.x                ; g = u * u
        mul r3.x, r0.w, r0.w                ; h = g * g
        mul r2.y, c1.y, r0.w                ; i.y = c_1.y * g
        mul r2.z, c1.z, r3.x                ; i.z = c_1.z * h
        mul r3.y, r3.x, r0.w                ; p_1 = h * g
        mul r2.w, c1.w, r3.y                ; i.w = c_1.w * p_1
        mov r2.x, c0.x                      ; i.x = c_0.x
        mul r0.w, c1.x, r0.y                ; p_0 = c_1.x * f
        mul r0.w, r0.w, r0.z                ; j = p_0 * e
        mul r3.x, c0.y, v0.x                ; p_0 = c_0.y * u
        mul r3, r3.x, r2                    ; p_1 = p_0.xxxx * i
        dp4 r3.x, c4, r3                    ; k = c_4 <.> p_1
        dp4 r3.y, c5, r2                    ; l = c_5 <.> i
        mul r3.z, r0.y, r0.y                ; p_2 = f * f
        mad r3.z, r0.z, r0.z, -r3.z         ; m = e * e - p_2
        mul r3.w, c1.x, r3.x                ; p_0 = c_1.x * k
        mul r3.w, r3.w, r3.y                ; n = p_0 * l
        mul r4.x, r3.x, r3.x                ; p_2 = k * k
        mad r4.x, r3.y, r3.y, -r4.x         ; o = l * l - p_2
        mul r4.y, r3.w, r3.z                ; p = n * m
        mul r4.z, r4.x, r3.z                ; q = o * m
        mul r4.w, r0.y, r0.z                ; p_1 = f * e
        mul r4.w, -c2.w, r4.w               ; r = -c_2.w * p_1
        mov r5.z, c2.z                      ; p_1.z = c_2.z
        mov r5.xy, r4.w                     ; p_1.x = r, p_1.y = r
        mov r6.yz, r3.xwz                   ; p_0.y = n, p_0.z = m
        mov r6.x, r4.x                      ; p_0.x = o
        mul r5.xyz, r6.xyz, r5.xyz          ; s = p_0 * p_1
        dp3 r4.w, r5.xyz, r5.xyz            ; t = s <.> s
        rsq r5.w, r4.w                      ; p_0 = rsq t
        mul r6.xyz, r5.w, r5.xyz            ; p_1 = p_0.xxx * s
        dp3 r5.w, c3.xyz, r6.xyz            ; w = c_3.xyz <.> p_1
        mul r6.x, r5.w, r5.w                ; p_0 = w * w
        add r6.x, -r6.x, c0.x               ; x = -p_0 + c_0.x
        rsq r6.y, r6.x                      ; p_0 = rsq x
        rcp r6.y, r6.y                      ; p_0 = rcp p_0
        mov r7.w, c0.x                      ; p_1.w = c_0.x
        mov r7.xyz, c10.w                   ; p_1.x = diffuse, p_1.y = diffuse, p_1.z = diffuse
        mul r7, r6.y, r7                    ; p_2 = p_0.xxxx * p_1
        mov r8.w, c0.x                      ; p_0.w = c_0.x
        mov r8.xyz, c3.w                    ; p_0.x = ambient, p_0.y = ambient, p_0.z = ambient
        mad r7, r8, c2.xyxy, r7             ; p_2 = p_0 * c_2.xyxy + p_2
        mov r6.w, r0.w                      ; p_1.z = j
        mov r6.yz, r4.xzy                   ; p_1.x = q, p_1.y = p
        add r6.yzw, c10.zxyz, -r6.wyzw      ; y = eyePos - p_1
        dp3 r8.x, r6.yzw, r5.xyz            ; z = y <.> s
        dp3 r8.y, r6.yzw, r6.yzw            ; aa = y <.> y
        mul r8.z, r4.w, r8.y                ; p_0 = t * aa
        rcp r8.z, r8.z                      ; p_0 = rcp p_0
        mul r8.w, r8.x, r8.x                ; p_1 = z * z
        mul r8.z, r8.z, r8.w                ; p_0 = p_0 * p_1
        add r8.z, -r8.z, c0.x               ; p_1 = -p_0 + c_0.x
        mul r8.z, r6.x, r8.z                ; p_0 = x * p_1
        rsq r8.z, r8.z                      ; p_0 = rsq p_0
        rcp r8.z, r8.z                      ; p_0 = rcp p_0
        mul r8.w, r8.y, r4.w                ; p_0 = aa * t
        rsq r8.w, r8.w                      ; p_0 = rsq p_0
        mul r8.w, r8.w, r8.x                ; p_1 = p_0 * z
        mul r8.w, r5.w, r8.w                ; p_1 = w * p_1
        add r6.y, r8.z, -r8.w               ; p_0 = p_0 - p_1
        log r6.y, r6.y                      ; p_0 = log p_0
        mul r6.y, r6.y, c11.y               ; p_0 = p_0 * power
        exp r6.y, r6.y                      ; p_0 = exp p_0
        mov r8.w, c0.x                      ; p_1.w = c_0.x
        mov r8.xyz, c11.x                   ; p_1.x = specular, p_1.y = specular, p_1.z = specular
        mad oD0, r6.y, r8, r7               ; oD0 = p_0.xxxx * p_1 + p_2
        mov r5.w, c0.x                      ; ba.w = c_0.x
        mov r5.z, r0.w                      ; ba.z = j
        mov r5.xy, r4.zy                    ; ba.x = q, ba.y = p
        dp4 oPos.x, r5, c6                  ; oPos.x = ba <.> world_1
        dp4 oPos.y, r5, c7                  ; oPos.y = ba <.> world_2
        dp4 oPos.z, r5, c8                  ; oPos.z = ba <.> world_3
        dp4 oPos.w, r5, c9                  ; oPos.w = ba <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float ambient = floats[0];
        float diffuse = floats[1];
        float specular = floats[2];
        float power = floats[3];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,1.5708f,3.14159f,0.5f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,2.4674f,6.08807f,15.0217f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,1.0f,6.28319f,12.5664f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.218218f,0.872872f,0.436436f,ambient});
        device.SetVertexShaderConstant(4, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(5, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(6, new Vector4[]{world_1});
        device.SetVertexShaderConstant(7, new Vector4[]{world_2});
        device.SetVertexShaderConstant(8, new Vector4[]{world_3});
        device.SetVertexShaderConstant(9, new Vector4[]{world_4});
        device.SetVertexShaderConstant(10, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,diffuse});
        device.SetVertexShaderConstant(11, 
                                       new float[]{specular,power,0.0f,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Anisotropic", 125, 125, new Anisotropic(), 
                        new VSlider[]
                        {
                          new VSlider("ambient", 0.0f, 1.0f, 0.1f),
                          new VSlider("diffuse", 0.0f, 1.0f, 0.3f),
                          new VSlider("specular", 0.0f, 1.0f, 0.6f),
                          new VSlider("power", 0.0f, 100.0f, 15.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
