// Vertex shader "BasicLightingNH", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class BasicLightingNH : VShader {
    // Vertex shader "BasicLightingNH".  Uses 23 float temporaries, 45 float
    // constants, and 69 instructions.
    public BasicLightingNH() : base(@"
        vs.1.1
        ; c0 = {3.14159, 0.5, 1.5708, 9.0}
        ; c1 = {1.0, 3.5, 0.2, 2.0}
        ; c2 = {0.0, 1.0, 11.3097, 0.0}
        ; c3 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c4 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c5 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c6, world_2 = c7, world_3 = c8, world_4 = c9, eyePos = c10.xyz, ambient = c2.w, diffuse = c3.w, specular = c10.w, power = c11.x
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, v0.x, v0.x                ; p_2 = u * u
        mad r0.x, v0.y, v0.y, r0.x          ; p_1 = v * v + p_2
        mul r0.x, c0.w, r0.x                ; p_0 = c_0.w * p_1
        rsq r0.x, r0.x                      ; a = rsq p_0
        rcp r0.y, r0.x                      ; p_0 = rcp a
        add r0.y, r0.y, c0.y                ; p_0 = p_0 + c_0.y
        expp r1, r0.y                       ; p_1 = expp p_0
        mad r0.y, c0.x, r1.y, -c0.z         ; b = c_0.x * p_1.y - c_0.z
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r0.w, r0.z, r0.z                ; d = c * c
        mul r1.w, r0.w, r0.z                ; e.w = d * c
        mov r1.x, c1.x                      ; e.x = c_1.x
        mov r1.yz, r0.xzw                   ; e.y = c, e.z = d
        mul r2, r0.y, r1                    ; p_1 = b.xxxx * e
        dp4 r0.z, c4, r2                    ; g = c_4 <.> p_1
        dp4 r0.w, c5, r1                    ; f = c_5 <.> e
        mul r2.z, c1.w, r0.z                ; p_0 = c_1.w * g
        mul r2.z, r2.z, r0.w                ; p_1.z = p_0 * f
        mov r2.xy, v0.xy                    ; p_1.x = u, p_1.y = v
        mov r3.xyz, c1.yyz                  ; p_0.x = c_1.y, p_0.y = c_1.y, p_0.z = c_1.z
        mul r2.xyz, r3.xyz, r2.xyz          ; h = p_0 * p_1
        mul r2.w, r0.w, r0.w                ; p_2 = f * f
        mad r2.w, -r0.z, r0.z, r2.w         ; i = -g * g + p_2
        mul r3.z, v0.y, r0.x                ; p_1 = v * a
        mul r3.z, r2.w, r3.z                ; p_1 = i * p_1
        mul r3.z, c2.z, r3.z                ; j.z = c_2.z * p_1
        mov r3.y, c1.y                      ; j.y = c_1.y
        mov r3.x, c2.x                      ; j.x = c_2.x
        dp3 r3.w, r3.xyz, r3.xyz            ; p_0 = j <.> j
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r3.xyz, r3.w, r3.xyz            ; l = p_0.xxx * j
        mul r3.w, v0.x, r0.x                ; p_1 = u * a
        mul r3.w, r2.w, r3.w                ; p_1 = i * p_1
        mul r4.z, c2.z, r3.w                ; k.z = c_2.z * p_1
        mov r4.x, c1.y                      ; k.x = c_1.y
        mov r4.y, c2.x                      ; k.y = c_2.x
        dp3 r3.w, r4.xyz, r4.xyz            ; p_0 = k <.> k
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r4.xyz, r3.w, r4.xyz            ; m = p_0.xxx * k
        mul r5.xyz, r4.yzx, r3.zxy          ; p_2 = m.yzx * l.zxy
        mad r3.xyz, -r3.yzx, r4.zxy, r5.xyz ; n = -l.yzx * m.zxy + p_2
        mov r4.w, c1.x                      ; p_0.w = c_1.x
        mov r4.xyz, c3.w                    ; p_0.x = diffuse, p_0.y = diffuse, p_0.z = diffuse
        dp3 r2.w, r3.xyz, c3.xyz            ; p_1 = n <.> c_3.xyz
        mov r5.w, c1.x                      ; p_2.w = c_1.x
        mov r5.xyz, c2.w                    ; p_2.x = ambient, p_2.y = ambient, p_2.z = ambient
        mad r4, r4, r2.w, r5                ; p_1 = p_0 * p_1.xxxx + p_2
        mul r4, c2.xyxy, r4                 ; p_2 = c_2.xyxy * p_1
        add r5.xyz, c10.xyz, -r2.xyz        ; o = eyePos - h
        dp3 r2.w, r5.xyz, r5.xyz            ; p_0 = o <.> o
        rsq r2.w, r2.w                      ; p_0 = rsq p_0
        mad r5.xyz, r2.w, r5.xyz, c3.xyz    ; p = p_0.xxx * o + c_3.xyz
        dp3 r2.w, r5.xyz, r5.xyz            ; p_0 = p <.> p
        rsq r2.w, r2.w                      ; p_0 = rsq p_0
        mul r5.xyz, r2.w, r5.xyz            ; p_1 = p_0.xxx * p
        dp3 r2.w, r3.xyz, r5.xyz            ; p_1 = n <.> p_1
        max r2.w, c2.x, r2.w                ; p_0 = max (c_2.x) p_1
        log r2.w, r2.w                      ; p_0 = log p_0
        mul r2.w, r2.w, c11.x               ; p_0 = p_0 * power
        exp r2.w, r2.w                      ; p_1 = exp p_0
        mov r5.w, c1.x                      ; p_0.w = c_1.x
        mov r5.xyz, c10.w                   ; p_0.x = specular, p_0.y = specular, p_0.z = specular
        mad oD0, r5, r2.w, r4               ; oD0 = p_0 * p_1.xxxx + p_2
        mov r3.w, c1.x                      ; q.w = c_1.x
        mov r3.xyz, r2.xyz                  ; q.x = h.x, q.y = h.y, q.z = h.z
        dp4 oPos.x, r3, c6                  ; oPos.x = q <.> world_1
        dp4 oPos.y, r3, c7                  ; oPos.y = q <.> world_2
        dp4 oPos.z, r3, c8                  ; oPos.z = q <.> world_3
        dp4 oPos.w, r3, c9                  ; oPos.w = q <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float ambient = floats[0];
        float diffuse = floats[1];
        float specular = floats[2];
        float power = floats[3];
        device.SetVertexShaderConstant(0, 
                                       new float[]{3.14159f,0.5f,1.5708f,9.0f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{1.0f,3.5f,0.2f,2.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,1.0f,11.3097f,ambient});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.218218f,0.872872f,0.436436f,diffuse});
        device.SetVertexShaderConstant(4, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(5, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(6, new Vector4[]{world_1});
        device.SetVertexShaderConstant(7, new Vector4[]{world_2});
        device.SetVertexShaderConstant(8, new Vector4[]{world_3});
        device.SetVertexShaderConstant(9, new Vector4[]{world_4});
        device.SetVertexShaderConstant(10, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,specular});
        device.SetVertexShaderConstant(11, 
                                       new float[]{power,0.0f,0.0f,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("BasicLightingNH", 
                        125, 
                        125, 
                        new BasicLightingNH(), 
                        new VSlider[]
                        {
                          new VSlider("ambient", 0.0f, 1.0f, 0.1f),
                          new VSlider("diffuse", 0.0f, 1.0f, 0.3f),
                          new VSlider("specular", 0.0f, 1.0f, 0.6f),
                          new VSlider("power", 0.0f, 100.0f, 15.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
