// Vertex shader "Dimple", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Dimple : VShader {
    // Vertex shader "Dimple".  Uses 17 float temporaries, 36 float
    // constants, and 55 instructions.
    public Dimple() : base(@"
        vs.1.1
        ; c0 = {3.0, 1.0, 0.111111, 9.0}
        ; c1 = {0.0, 2.0, 15.0, 18.0}
        ; c2 = {0.4, 1.0, 0.3, 0.6}
        ; c3 = {0.0, 1.0, 0.0, 0.0}
        ; c4 = {0.218218, 0.872872, 0.436436, 0.0}
        ; uniform: world_1 = c5, world_2 = c6, world_3 = c7, world_4 = c8, eyePos = c9.xyz
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, v0.x, v0.x                ; p_2 = u * u
        mad r0.x, v0.y, v0.y, r0.x          ; a = v * v + p_2
        mad r0.y, -c0.w, r0.x, c0.y         ; b = -c_0.w * a + c_0.y
        slt r0.z, r0.x, c0.z                ; c = a < c_0.z
        rsq r0.w, r0.y                      ; d = rsq b
        mov r1.xy, c0.x                     ; p_0.x = c_0.x, p_0.y = c_0.x
        mov r1.z, r0.z                      ; p_0.z = c
        rcp r2.z, r0.w                      ; p_1.z = rcp d
        mov r2.xy, v0.xy                    ; p_1.x = u, p_1.y = v
        mul r1.xyz, r1.xyz, r2.xyz          ; e = p_0 * p_1
        mul r1.w, c1.y, r0.y                ; p_0 = c_1.y * b
        rcp r1.w, r1.w                      ; f = rcp p_0
        mul r2.z, -c1.w, v0.y               ; p_0 = -c_1.w * v
        mul r2.z, r2.z, r0.w                ; p_0 = p_0 * d
        mul r2.z, r2.z, r1.w                ; p_0 = p_0 * f
        mul r2.z, r2.z, r0.y                ; p_1 = p_0 * b
        mul r2.z, r0.z, r2.z                ; g.z = c * p_1
        mov r2.y, c0.x                      ; g.y = c_0.x
        mov r2.x, c1.x                      ; g.x = c_1.x
        dp3 r2.w, r2.xyz, r2.xyz            ; p_0 = g <.> g
        rsq r2.w, r2.w                      ; p_0 = rsq p_0
        mul r2.xyz, r2.w, r2.xyz            ; i = p_0.xxx * g
        mul r2.w, -c1.w, v0.x               ; p_0 = -c_1.w * u
        mul r2.w, r2.w, r0.w                ; p_0 = p_0 * d
        mul r2.w, r2.w, r1.w                ; p_0 = p_0 * f
        mul r2.w, r2.w, r0.y                ; p_1 = p_0 * b
        mul r3.z, r0.z, r2.w                ; h.z = c * p_1
        mov r3.x, c0.x                      ; h.x = c_0.x
        mov r3.y, c1.x                      ; h.y = c_1.x
        dp3 r2.w, r3.xyz, r3.xyz            ; p_0 = h <.> h
        rsq r2.w, r2.w                      ; p_0 = rsq p_0
        mul r3.xyz, r2.w, r3.xyz            ; j = p_0.xxx * h
        mul r4.xyz, r3.yzx, r2.zxy          ; p_2 = j.yzx * i.zxy
        mad r2.xyz, -r2.yzx, r3.zxy, r4.xyz ; k = -i.yzx * j.zxy + p_2
        dp3 r1.w, r2.xyz, c4.xyz            ; l = k <.> c_4.xyz
        add r3.xyz, c9.xyz, -r1.xyz         ; m = eyePos - e
        dp3 r2.w, r3.xyz, r3.xyz            ; p_0 = m <.> m
        rsq r2.w, r2.w                      ; p_0 = rsq p_0
        mul r3.xyz, r2.w, r3.xyz            ; p_1 = p_0.xxx * m
        mul r2.w, c1.y, r1.w                ; p_0 = c_1.y * l
        mad r4.xyz, r2.w, r2.xyz, -c4.xyz   ; p_0 = p_0.xxx * k - c_4.xyz
        dp3 r2.w, r4.xyz, r3.xyz            ; p_1 = p_0 <.> p_1
        max r2.w, c1.x, r2.w                ; p_0 = max (c_1.x) p_1
        log r2.w, r2.w                      ; p_0 = log p_0
        mul r2.w, r2.w, c1.z                ; p_0 = p_0 * c_1.z
        exp r2.w, r2.w                      ; p_1 = exp p_0
        mad r3, c2.xxxy, r1.w, c2.zzzy      ; p_1 = c_2.xxxy * l.xxxx + c_2.zzzy
        mul r3, c3.xyxy, r3                 ; p_2 = c_3.xyxy * p_1
        mad oD0, c2.wwwy, r2.w, r3          ; oD0 = c_2.wwwy * p_1.xxxx + p_2
        mov r2.w, c0.y                      ; n.w = c_0.y
        mov r2.xyz, r1.xyz                  ; n.x = e.x, n.y = e.y, n.z = e.z
        dp4 oPos.x, r2, c5                  ; oPos.x = n <.> world_1
        dp4 oPos.y, r2, c6                  ; oPos.y = n <.> world_2
        dp4 oPos.z, r2, c7                  ; oPos.z = n <.> world_3
        dp4 oPos.w, r2, c8                  ; oPos.w = n <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        device.SetVertexShaderConstant(0, 
                                       new float[]{3.0f,1.0f,0.111111f,9.0f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.0f,2.0f,15.0f,18.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.4f,1.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.0f,1.0f,0.0f,0.0f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(5, new Vector4[]{world_1});
        device.SetVertexShaderConstant(6, new Vector4[]{world_2});
        device.SetVertexShaderConstant(7, new Vector4[]{world_3});
        device.SetVertexShaderConstant(8, new Vector4[]{world_4});
        device.SetVertexShaderConstant(9, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Dimple", 125, 125, new Dimple(), 
                        new VSlider[]
                        {
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
