// Vertex shader "DimpledCylinder", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class DimpledCylinder : VShader {
    // Vertex shader "DimpledCylinder".  Uses 37 float temporaries, 56 float
    // constants, and 108 instructions.
    public DimpledCylinder() : base(@"
        vs.1.1
        ; c0 = {1.0, 0.5, 3.14159, 1.5708}
        ; c1 = {2.0, 0.75, 3.75, 3.0}
        ; c2 = {0.0, 9.0, 6.28319, 4.5}
        ; c3 = {15.0, 12.5664, 18.0, 0.0}
        ; c4 = {0.4, 1.0, 0.3, 0.6}
        ; c5 = {0.0, 1.0, 0.0, 0.0}
        ; c6 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c7 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c8 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c9 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c10, world_2 = c11, world_3 = c12, world_4 = c13, eyePos = c14.xyz, spacing = c3.w, squeeze = c5.z
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, -v0.y, c0.y               ; p_0 = -v + c_0.y
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.z, r0.y, -c0.w         ; a = c_0.z * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mov r2, c0                          ; p_1 = c_0
        mul r0.y, c3.w, r2.y                ; f = spacing * p_1.y
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.z, c8, r2                    ; h = c_8 <.> p_1
        rcp r0.w, c3.w                      ; e = rcp spacing
        dp4 r2.x, c9, r1                    ; g = c_9 <.> d
        mul r2.y, v0.x, c1.x                ; p_1 = u * c_1.x
        mad r2.y, c5.z, r2.y, r0.y          ; p_0 = squeeze * p_1 + f
        mul r2.y, r2.y, r0.w                ; p_0 = p_0 * e
        expp r3, r2.y                       ; i = expp p_0
        mul r2.y, v0.y, c1.w                ; p_1 = v * c_1.w
        mad r2.y, c5.z, r2.y, r0.y          ; p_0 = squeeze * p_1 + f
        mul r2.y, r2.y, r0.w                ; p_0 = p_0 * e
        expp r4, r2.y                       ; j = expp p_0
        add r2.y, r4.y, -c0.y               ; l = j.y - c_0.y
        add r2.z, r3.y, -c0.y               ; k = i.y - c_0.y
        mul r2.z, r2.z, r2.z                ; p_2 = k * k
        mad r2.y, r2.y, r2.y, r2.z          ; p_1 = l * l + p_2
        mul r2.z, c3.w, c3.w                ; p_0 = spacing * spacing
        mul r2.y, r2.z, r2.y                ; m = p_0 * p_1
        add r2.z, -r2.y, c0.x               ; n = -m + c_0.x
        slt r2.w, r2.y, c0.x                ; o = m < c_0.x
        rsq r5.x, r2.z                      ; p = rsq n
        rcp r5.y, r5.x                      ; p_1 = rcp p
        mul r5.y, r2.w, r5.y                ; p_1 = o * p_1
        rcp r5.z, c5.z                      ; p_0 = rcp squeeze
        mul r5.y, r5.z, r5.y                ; p_1 = p_0 * p_1
        mov r6, c0                          ; p_2 = c_0
        mad r5.y, c1.w, r5.y, r6.x          ; r = c_1.w * p_1 + p_2.x
        mul r5.z, r2.x, r2.x                ; p_2 = g * g
        mad r5.z, -r0.z, r0.z, r5.z         ; q = -h * h + p_2
        mul r6.x, r5.z, r5.y                ; p_1.x = q * r
        mul r5.w, c1.x, r0.z                ; p_0 = c_1.x * h
        mul r5.w, r5.w, r2.x                ; p_0 = p_0 * g
        mul r6.y, r5.w, r5.y                ; p_1.y = p_0 * r
        mov r6.z, v0.x                      ; p_1.z = u
        mov r7.xyz, c1.yyz                  ; p_0.x = c_1.y, p_0.y = c_1.y, p_0.z = c_1.z
        mul r6.xyz, r7.xyz, r6.xyz          ; s = p_0 * p_1
        mul r5.w, c1.x, r2.z                ; p_0 = c_1.x * n
        rcp r5.w, r5.w                      ; t = rcp p_0
        mul r6.w, r0.z, r2.x                ; w = h * g
        mov r8, c0                          ; p_2 = c_0
        mad r7.w, r4.y, c1.x, -r8.x         ; p_1 = j.y * c_1.x - p_2.x
        mul r7.w, c3.w, r7.w                ; p_0 = spacing * p_1
        mul r7.w, r7.w, r5.x                ; p_0 = p_0 * p
        mul r7.w, r7.w, r5.w                ; p_0 = p_0 * t
        mul r7.w, r7.w, r2.z                ; p_1 = p_0 * n
        mul r7.w, r2.w, r7.w                ; x = o * p_1
        mul r8.x, -c2.y, r7.w               ; p_1 = -c_2.y * x
        mul r8.x, r5.z, r8.x                ; p_2 = q * p_1
        mul r8.y, c3.y, r6.w                ; p_1 = c_3.y * w
        mad r8.x, r5.y, r8.y, r8.x          ; p_1 = r * p_1 + p_2
        mul r7.x, c1.y, r8.x                ; y.x = c_1.y * p_1
        mul r8.x, r6.w, r7.w                ; p_1 = w * x
        mul r8.x, -c3.z, r8.x               ; p_2 = -c_3.z * p_1
        mul r8.y, r5.z, -c2.z               ; p_1 = q * -c_2.z
        mad r8.x, r5.y, r8.y, r8.x          ; p_1 = r * p_1 + p_2
        mul r7.y, c1.y, r8.x                ; y.y = c_1.y * p_1
        mov r7.z, c2.x                      ; y.z = c_2.x
        dp3 r7.w, r7.xyz, r7.xyz            ; p_0 = y <.> y
        rsq r7.w, r7.w                      ; p_0 = rsq p_0
        mul r7.xyz, r7.w, r7.xyz            ; ba = p_0.xxx * y
        mov r9, c0                          ; p_2 = c_0
        mad r7.w, r3.y, c1.x, -r9.x         ; p_1 = i.y * c_1.x - p_2.x
        mul r7.w, c3.w, r7.w                ; p_0 = spacing * p_1
        mul r7.w, r7.w, r5.x                ; p_0 = p_0 * p
        mul r7.w, r7.w, r5.w                ; p_0 = p_0 * t
        mul r7.w, r7.w, r2.z                ; p_1 = p_0 * n
        mul r7.w, r2.w, r7.w                ; z = o * p_1
        mul r8.w, r5.z, r7.w                ; p_1 = q * z
        mul r8.x, -c2.w, r8.w               ; aa.x = -c_2.w * p_1
        mul r8.w, r6.w, r7.w                ; p_1 = w * z
        mul r8.y, -c2.y, r8.w               ; aa.y = -c_2.y * p_1
        mov r8.z, c1.z                      ; aa.z = c_1.z
        dp3 r7.w, r8.xyz, r8.xyz            ; p_0 = aa <.> aa
        rsq r7.w, r7.w                      ; p_0 = rsq p_0
        mul r8.xyz, r7.w, r8.xyz            ; ca = p_0.xxx * aa
        mul r9.xyz, r8.yzx, r7.zxy          ; p_2 = ca.yzx * ba.zxy
        mad r7.xyz, -r7.yzx, r8.zxy, r9.xyz ; da = -ba.yzx * ca.zxy + p_2
        dp3 r5.w, r7.xyz, c6.xyz            ; ea = da <.> c_6.xyz
        add r8.xyz, c14.xyz, -r6.xyz        ; fa = eyePos - s
        dp3 r6.w, r8.xyz, r8.xyz            ; p_0 = fa <.> fa
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r8.xyz, r6.w, r8.xyz            ; p_1 = p_0.xxx * fa
        mul r6.w, c1.x, r5.w                ; p_0 = c_1.x * ea
        mad r9.xyz, r6.w, r7.xyz, -c6.xyz   ; p_0 = p_0.xxx * da - c_6.xyz
        dp3 r6.w, r9.xyz, r8.xyz            ; p_1 = p_0 <.> p_1
        max r6.w, c2.x, r6.w                ; p_0 = max (c_2.x) p_1
        log r6.w, r6.w                      ; p_0 = log p_0
        mul r6.w, r6.w, c3.x                ; p_0 = p_0 * c_3.x
        exp r6.w, r6.w                      ; p_1 = exp p_0
        mad r8, c4.xxxy, r5.w, c4.zzzy      ; p_1 = c_4.xxxy * ea.xxxx + c_4.zzzy
        mul r8, c5.xyxy, r8                 ; p_2 = c_5.xyxy * p_1
        mad oD0, c4.wwwy, r6.w, r8          ; oD0 = c_4.wwwy * p_1.xxxx + p_2
        mov r7.w, c0.x                      ; ga.w = c_0.x
        mov r7.xyz, r6.xyz                  ; ga.x = s.x, ga.y = s.y, ga.z = s.z
        dp4 oPos.x, r7, c10                 ; oPos.x = ga <.> world_1
        dp4 oPos.y, r7, c11                 ; oPos.y = ga <.> world_2
        dp4 oPos.z, r7, c12                 ; oPos.z = ga <.> world_3
        dp4 oPos.w, r7, c13                 ; oPos.w = ga <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float spacing = floats[0];
        float squeeze = floats[1];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,0.5f,3.14159f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,0.75f,3.75f,3.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,9.0f,6.28319f,4.5f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{15.0f,12.5664f,18.0f,spacing});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.4f,1.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(5, 
                                       new float[]{0.0f,1.0f,squeeze,0.0f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,0.0f});
        device.SetVertexShaderConstant(8, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(9, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(10, new Vector4[]{world_1});
        device.SetVertexShaderConstant(11, new Vector4[]{world_2});
        device.SetVertexShaderConstant(12, new Vector4[]{world_3});
        device.SetVertexShaderConstant(13, new Vector4[]{world_4});
        device.SetVertexShaderConstant(14, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("DimpledCylinder", 
                        125, 
                        125, 
                        new DimpledCylinder(), 
                        new VSlider[]
                        {
                          new VSlider("spacing", 0.0f, 5.0f, 2.5f),
                          new VSlider("squeeze", 0.0f, 15.0f, 3.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
