// Vertex shader "EggcrateCylinder", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class EggcrateCylinder : VShader {
    // Vertex shader "EggcrateCylinder".  Uses 38 float temporaries, 55
    // float constants, and 112 instructions.
    public EggcrateCylinder() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {2.0, 0.75, 4.0, 8.0}
        ; c2 = {0.0, 4.71239, 12.5664, 6.28319}
        ; c3 = {0.3, 1.0, 0.6, 15.0}
        ; c4 = {1.0, 0.0, 0.4, 0.0}
        ; c5 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c6 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c7 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c8 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c9, world_2 = c10, world_3 = c11, world_4 = c12, eyePos = c13.xyz, frequency = c4.w, magnitude = c5.w, height = c6.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, -v0.y, c0.z               ; p_0 = -v + c_0.z
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.y, r0.y, -c0.w         ; a = c_0.y * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.y, c7, r2                    ; f = c_7 <.> p_1
        dp4 r0.z, c8, r1                    ; e = c_8 <.> d
        mov r2, c0                          ; p_2 = c_0
        mad r0.w, c4.w, v0.x, r2.z          ; p_0 = frequency * u + p_2.z
        expp r2, r0.w                       ; p_1 = expp p_0
        mad r0.w, c0.y, r2.y, -c0.w         ; g = c_0.y * p_1.y - c_0.w
        mul r2.x, r0.z, r0.z                ; p_2 = e * e
        mad r2.x, -r0.y, r0.y, r2.x         ; h = -f * f + p_2
        mul r2.y, c1.x, r0.y                ; p_0 = c_1.x * f
        mul r2.y, r2.y, r0.z                ; i = p_0 * e
        mul r2.z, r0.w, r0.w                ; j = g * g
        mul r2.w, r2.z, r2.z                ; k = j * j
        mul r3.w, r2.w, r2.z                ; l.w = k * j
        mov r3.x, c0.x                      ; l.x = c_0.x
        mov r3.yz, r2.xzw                   ; l.y = j, l.z = k
        mov r4, c0                          ; p_2 = c_0
        mad r2.z, c4.w, v0.y, r4.z          ; p_0 = frequency * v + p_2.z
        expp r4, r2.z                       ; p_1 = expp p_0
        mad r2.z, c0.y, r4.y, -c0.w         ; m = c_0.y * p_1.y - c_0.w
        mul r4, r0.w, r3                    ; p_1 = g.xxxx * l
        dp4 r2.w, c7, r4                    ; n = c_7 <.> p_1
        dp4 r4.x, c8, r3                    ; o = c_8 <.> l
        mul r4.y, r2.z, r2.z                ; p = m * m
        mul r4.z, r4.y, r4.y                ; q = p * p
        mul r5.w, r4.z, r4.y                ; r.w = q * p
        mov r5.x, c0.x                      ; r.x = c_0.x
        mov r5.yz, r4.xyz                   ; r.y = p, r.z = q
        mul r6, r2.z, r5                    ; p_1 = m.xxxx * r
        dp4 r4.y, c7, r6                    ; t = c_7 <.> p_1
        mul r4.z, r4.x, r4.x                ; p_2 = o * o
        mad r4.z, -r2.w, r2.w, r4.z         ; s = -n * n + p_2
        dp4 r4.w, c8, r5                    ; w = c_8 <.> r
        mul r6.x, c1.x, r4.y                ; p_0 = c_1.x * t
        mul r6.x, r6.x, r4.w                ; p_1 = p_0 * w
        mul r6.x, r4.z, r6.x                ; p_1 = s * p_1
        mov r7, c0                          ; p_2 = c_0
        mad r6.x, c5.w, r6.x, r7.x          ; x = magnitude * p_1 + p_2.x
        mov r6.w, c6.w                      ; p_0.z = height
        mov r6.yz, r2.xxy                   ; p_0.x = h, p_0.y = i
        mov r7.z, v0.x                      ; p_1.z = u
        mov r7.xy, r6.x                     ; p_1.x = x, p_1.y = x
        mul r6.yzw, r6.wyzw, r7.zxyz        ; y = p_0 * p_1
        mul r7.x, r0.y, r0.z                ; z = f * e
        mul r8.x, r4.w, r4.w                ; p_2 = w * w
        mad r8.x, -r4.y, r4.y, r8.x         ; p_0 = -t * t + p_2
        mul r8.x, r8.x, c4.w                ; p_1 = p_0 * frequency
        mul r8.x, r4.z, r8.x                ; p_1 = s * p_1
        mul r8.x, c5.w, r8.x                ; aa = magnitude * p_1
        mul r8.y, r2.x, r8.x                ; p_2 = h * aa
        mad r8.y, r6.x, r2.y, r8.y          ; p_1 = x * i + p_2
        mul r7.y, c2.y, r8.y                ; ba.x = c_2.y * p_1
        mul r8.y, r7.x, r8.x                ; p_1 = z * aa
        mul r8.y, c2.z, r8.y                ; p_2 = c_2.z * p_1
        mul r8.z, r2.x, -c2.w               ; p_1 = h * -c_2.w
        mad r8.y, r6.x, r8.z, r8.y          ; p_1 = x * p_1 + p_2
        mul r7.z, c1.y, r8.y                ; ba.y = c_1.y * p_1
        mov r7.w, c2.x                      ; ba.z = c_2.x
        dp3 r8.x, r7.yzw, r7.yzw            ; p_0 = ba <.> ba
        rsq r8.x, r8.x                      ; p_0 = rsq p_0
        mul r7.yzw, r8.x, r7.wyzw           ; ea = p_0.xxx * ba
        mul r8.w, r2.w, r4.x                ; p_0 = n * o
        mul r8.w, r8.w, c4.w                ; p_1 = p_0 * frequency
        mul r9.x, r4.y, r4.w                ; p_0 = t * w
        mul r8.w, r9.x, r8.w                ; ca = p_0 * p_1
        mul r9.x, c1.z, r8.w                ; p_1 = c_1.z * ca
        mul r9.x, c5.w, r9.x                ; p_1 = magnitude * p_1
        mul r8.x, r2.x, r9.x                ; p_1.x = h * p_1
        mul r9.x, c5.w, r8.w                ; p_1 = magnitude * ca
        mul r9.x, r7.x, r9.x                ; p_1 = z * p_1
        mul r8.y, c1.w, r9.x                ; p_1.y = c_1.w * p_1
        mov r8.z, c6.w                      ; p_1.z = height
        mov r9.z, c1.y                      ; p_0.z = c_1.y
        mov r9.xy, -c2.y                    ; p_0.x = -c_2.y, p_0.y = -c_2.y
        mul r8.xyz, r9.xyz, r8.xyz          ; da = p_0 * p_1
        dp3 r8.w, r8.xyz, r8.xyz            ; p_0 = da <.> da
        rsq r8.w, r8.w                      ; p_0 = rsq p_0
        mul r8.xyz, r8.w, r8.xyz            ; fa = p_0.xxx * da
        mul r9.xyz, r8.yzx, r7.wyz          ; p_2 = fa.yzx * ea.zxy
        mad r7.xyz, -r7.zwy, r8.zxy, r9.xyz ; ga = -ea.yzx * fa.zxy + p_2
        dp3 r7.w, r7.xyz, c5.xyz            ; ha = ga <.> c_5.xyz
        mov r8.xyz, c13.xyz                 ; p_2 = eyePos
        mad r8.xyz, -c1.y, r6.yzw, r8.xyz   ; ia = -c_1.yyy * y + p_2
        dp3 r8.w, r8.xyz, r8.xyz            ; p_0 = ia <.> ia
        rsq r8.w, r8.w                      ; p_0 = rsq p_0
        mul r8.xyz, r8.w, r8.xyz            ; p_1 = p_0.xxx * ia
        mul r8.w, c1.x, r7.w                ; p_0 = c_1.x * ha
        mad r9.xyz, r8.w, r7.xyz, -c5.xyz   ; p_0 = p_0.xxx * ga - c_5.xyz
        dp3 r8.x, r9.xyz, r8.xyz            ; p_1 = p_0 <.> p_1
        max r8.x, c2.x, r8.x                ; p_0 = max (c_2.x) p_1
        log r8.x, r8.x                      ; p_0 = log p_0
        mul r8.x, r8.x, c3.w                ; p_0 = p_0 * c_3.w
        exp r8.x, r8.x                      ; p_1 = exp p_0
        mov r9, c3                          ; p_2 = c_3
        mad r9, c4.zzzx, r7.w, r9.xxxy      ; p_1 = c_4.zzzx * ha.xxxx + p_2.xxxy
        mul r9, c4.xyyx, r9                 ; p_2 = c_4.xyyx * p_1
        mad oD0, c3.zzzy, r8.x, r9          ; oD0 = c_3.zzzy * p_1.xxxx + p_2
        mul r8.xyz, c1.y, r6.yzw            ; ja = c_1.yyy * y
        mov r7.w, c0.x                      ; ka.w = c_0.x
        mov r7.xyz, r8.xyz                  ; ka.x = ja.x, ka.y = ja.y, ka.z = ja.z
        dp4 oPos.x, r7, c9                  ; oPos.x = ka <.> world_1
        dp4 oPos.y, r7, c10                 ; oPos.y = ka <.> world_2
        dp4 oPos.z, r7, c11                 ; oPos.z = ka <.> world_3
        dp4 oPos.w, r7, c12                 ; oPos.w = ka <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float frequency = floats[0];
        float magnitude = floats[1];
        float height = floats[2];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,0.75f,4.0f,8.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,4.71239f,12.5664f,6.28319f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.3f,1.0f,0.6f,15.0f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{1.0f,0.0f,0.4f,frequency});
        device.SetVertexShaderConstant(5, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,magnitude});
        device.SetVertexShaderConstant(6, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,height});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(8, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(9, new Vector4[]{world_1});
        device.SetVertexShaderConstant(10, new Vector4[]{world_2});
        device.SetVertexShaderConstant(11, new Vector4[]{world_3});
        device.SetVertexShaderConstant(12, new Vector4[]{world_4});
        device.SetVertexShaderConstant(13, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("EggcrateCylinder", 
                        125, 
                        125, 
                        new EggcrateCylinder(), 
                        new VSlider[]
                        {
                          new VSlider("frequency", 0.0f, 8.0f, 3.0f),
                          new VSlider("magnitude", 0.0f, 1.0f, 0.15f),
                          new VSlider("height", 0.0f, 10.0f, 3.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
