// Vertex shader "HelicalTube", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class HelicalTube : VShader {
    // Vertex shader "HelicalTube".  Uses 32 float temporaries, 51 float
    // constants, and 90 instructions.
    public HelicalTube() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {2.0, 15.0, 12.5664, 6.28319}
        ; c2 = {1.0, 0.0, 0.3, 0.6}
        ; c3 = {0.4, 1.0, 0.0, 0.0}
        ; c4 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c5 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, periods = c3.z, zrate = c3.w, sweepRad = c4.w, crossRad = c5.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, v0.y, c3.z                ; a = v * periods
        add r0.y, -r0.x, c0.z               ; p_0 = -a + c_0.z
        expp r1, r0.y                       ; p_1 = expp p_0
        mad r0.y, c0.y, r1.y, -c0.w         ; b = c_0.y * p_1.y - c_0.w
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r0.w, r0.z, r0.z                ; d = c * c
        mul r1.w, r0.w, r0.z                ; e.w = d * c
        mov r1.x, c0.x                      ; e.x = c_0.x
        mov r1.yz, r0.xzw                   ; e.y = c, e.z = d
        mul r2, r0.y, r1                    ; p_1 = b.xxxx * e
        dp4 r0.z, c6, r2                    ; g = c_6 <.> p_1
        dp4 r0.w, c7, r1                    ; f = c_7 <.> e
        add r2.x, v0.x, c0.z                ; p_0 = u + c_0.z
        expp r2, r2.x                       ; p_1 = expp p_0
        mad r2.x, c0.y, r2.y, -c0.w         ; h = c_0.y * p_1.y - c_0.w
        mul r2.y, r0.w, r0.w                ; p_2 = f * f
        mad r2.y, -r0.z, r0.z, r2.y         ; i = -g * g + p_2
        mul r2.z, r2.x, r2.x                ; j = h * h
        mul r2.w, r2.z, r2.z                ; k = j * j
        mul r3.w, r2.w, r2.z                ; l.w = k * j
        mov r3.x, c0.x                      ; l.x = c_0.x
        mov r3.yz, r2.xzw                   ; l.y = j, l.z = k
        mul r4, r2.x, r3                    ; p_1 = h.xxxx * l
        dp4 r2.z, c6, r4                    ; n = c_6 <.> p_1
        dp4 r2.w, c7, r3                    ; m = c_7 <.> l
        mul r4.x, c1.x, r0.z                ; p_0 = c_1.x * g
        mul r4.x, r4.x, r0.w                ; o = p_0 * f
        mul r4.y, r2.w, r2.w                ; p_2 = m * m
        mad r4.y, -r2.z, r2.z, r4.y         ; p = -n * n + p_2
        mul r4.z, c1.x, r2.z                ; p_0 = c_1.x * n
        mul r4.z, r4.z, r2.w                ; p_1 = p_0 * m
        mul r4.z, c5.w, r4.z                ; p_2 = crossRad * p_1
        mad r4.z, c3.w, r0.x, r4.z          ; q = zrate * a + p_2
        mov r4.w, c4.w                      ; p_2 = sweepRad
        mad r4.w, c5.w, r4.y, r4.w          ; r = crossRad * p + p_2
        mul r5.x, r4.w, r2.y                ; s = r * i
        mul r5.y, r4.w, r4.x                ; t = r * o
        mul r5.z, r2.z, r2.w                ; p_1 = n * m
        mul r5.z, -c1.z, r5.z               ; x = -c_1.z * p_1
        mov r6.z, c1.w                      ; p_1.z = c_1.w
        mov r6.xy, r5.z                     ; p_1.x = x, p_1.y = x
        mov r7.xy, c5.w                     ; p_0.x = crossRad, p_0.y = crossRad
        mov r7.z, r4.y                      ; p_0.z = p
        mul r6.xyz, r7.xyz, r6.xyz          ; p_1 = p_0 * p_1
        mov r7.z, c5.w                      ; p_0.z = crossRad
        mov r7.x, r2.y                      ; p_0.x = i
        mov r7.y, r4.x                      ; p_0.y = o
        mul r6.xyz, r7.xyz, r6.xyz          ; y = p_0 * p_1
        dp3 r5.z, r6.xyz, r6.xyz            ; p_0 = y <.> y
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r6.xyz, r5.z, r6.xyz            ; aa = p_0.xxx * y
        mul r5.z, r0.z, r0.w                ; p_0 = g * f
        mul r5.z, r5.z, c3.z                ; p_1 = p_0 * periods
        mul r5.z, -c1.z, r5.z               ; p_1 = -c_1.z * p_1
        mul r7.x, -r4.w, r5.z               ; w.x = -r * p_1
        mov r5.z, c3.z                      ; p_1 = periods
        mul r5.z, -c1.w, r5.z               ; p_1 = -c_1.w * p_1
        mul r5.z, r2.y, r5.z                ; p_1 = i * p_1
        mul r7.y, r4.w, r5.z                ; w.y = r * p_1
        mul r7.z, c3.w, c3.z                ; w.z = zrate * periods
        dp3 r5.z, r7.xyz, r7.xyz            ; p_0 = w <.> w
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r7.xyz, r5.z, r7.xyz            ; z = p_0.xxx * w
        mul r8.xyz, r6.yzx, r7.zxy          ; p_2 = aa.yzx * z.zxy
        mad r6.xyz, -r7.yzx, r6.zxy, r8.xyz ; ba = -z.yzx * aa.zxy + p_2
        dp3 r5.z, r6.xyz, c4.xyz            ; ca = ba <.> c_4.xyz
        mov r7.z, r4.z                      ; p_1.z = q
        mov r7.xy, r5.xy                    ; p_1.x = s, p_1.y = t
        add r7.xyz, c12.xyz, -r7.xyz        ; da = eyePos - p_1
        dp3 r5.w, r7.xyz, r7.xyz            ; p_0 = da <.> da
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r7.xyz, r5.w, r7.xyz            ; p_1 = p_0.xxx * da
        mul r5.w, c1.x, r5.z                ; p_0 = c_1.x * ca
        mad r8.xyz, r5.w, r6.xyz, -c4.xyz   ; p_0 = p_0.xxx * ba - c_4.xyz
        dp3 r5.w, r8.xyz, r7.xyz            ; p_1 = p_0 <.> p_1
        max r5.w, c2.y, r5.w                ; p_0 = max (c_2.y) p_1
        log r5.w, r5.w                      ; p_0 = log p_0
        mul r5.w, r5.w, c1.y                ; p_0 = p_0 * c_1.y
        exp r5.w, r5.w                      ; p_1 = exp p_0
        mov r7, c2                          ; p_2 = c_2
        mad r7, c3.xxxy, r5.z, r7.zzzx      ; p_1 = c_3.xxxy * ca.xxxx + p_2.zzzx
        mul r7, c2.xyyx, r7                 ; p_2 = c_2.xyyx * p_1
        mad oD0, c2.wwwx, r5.w, r7          ; oD0 = c_2.wwwx * p_1.xxxx + p_2
        mov r6.w, c0.x                      ; ea.w = c_0.x
        mov r6.z, r4.z                      ; ea.z = q
        mov r6.xy, r5.xy                    ; ea.x = s, ea.y = t
        dp4 oPos.x, r6, c8                  ; oPos.x = ea <.> world_1
        dp4 oPos.y, r6, c9                  ; oPos.y = ea <.> world_2
        dp4 oPos.z, r6, c10                 ; oPos.z = ea <.> world_3
        dp4 oPos.w, r6, c11                 ; oPos.w = ea <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float periods = floats[0];
        float zrate = floats[1];
        float sweepRad = floats[2];
        float crossRad = floats[3];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,15.0f,12.5664f,6.28319f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{1.0f,0.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,periods,zrate});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,sweepRad});
        device.SetVertexShaderConstant(5, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,crossRad});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("HelicalTube", 75, 200, new HelicalTube(), 
                        new VSlider[]
                        {
                          new VSlider("periods", 0.0f, 10.0f, 5.0f),
                          new VSlider("zrate", 0.0f, 2.0f, 0.8f),
                          new VSlider("sweepRad", 0.0f, 3.0f, 0.7f),
                          new VSlider("crossRad", 0.0f, 3.0f, 0.25f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
