// Vertex shader "Plane", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Plane : VShader {
    // Vertex shader "Plane".  Uses 10 float temporaries, 31 float
    // constants, and 21 instructions.
    public Plane() : base(@"
        vs.1.1
        ; c0 = {0.0, 15.0, 1.0, 3.0}
        ; c1 = {0.6, 1.0, 0.0, 0.0}
        ; c2 = {0.0, 0.274574, 1.43644, 0.0}
        ; c3 = {-0.218218, -0.872872, 0.436436, 0.0}
        ; uniform: world_1 = c4, world_2 = c5, world_3 = c6, world_4 = c7, eyePos = c8.xyz
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, c0.w, v0.x                ; a = c_0.w * u
        mul r0.y, c0.w, v0.y                ; b = c_0.w * v
        mov r1.z, c0.x                      ; p_1.z = c_0.x
        mov r1.xy, r0.xy                    ; p_1.x = a, p_1.y = b
        add r1.xyz, c8.xyz, -r1.xyz         ; c = eyePos - p_1
        dp3 r0.z, r1.xyz, r1.xyz            ; p_0 = c <.> c
        rsq r0.z, r0.z                      ; p_0 = rsq p_0
        mul r1.xyz, r0.z, r1.xyz            ; p_1 = p_0.xxx * c
        dp3 r0.z, c3.xyz, r1.xyz            ; p_1 = c_3.xyz <.> p_1
        max r0.z, c0.x, r0.z                ; p_0 = max (c_0.x) p_1
        log r0.z, r0.z                      ; p_0 = log p_0
        mul r0.z, r0.z, c0.y                ; p_0 = p_0 * c_0.y
        exp r0.z, r0.z                      ; p_1 = exp p_0
        mov r1, c2                          ; p_2 = c_2
        mad oD0, c1.xxxy, r0.z, r1.xxyz     ; oD0 = c_1.xxxy * p_1.xxxx + p_2.xxyz
        mov r1.zw, c0.xyxz                  ; d.z = c_0.x, d.w = c_0.z
        mov r1.xy, r0.xy                    ; d.x = a, d.y = b
        dp4 oPos.x, r1, c4                  ; oPos.x = d <.> world_1
        dp4 oPos.y, r1, c5                  ; oPos.y = d <.> world_2
        dp4 oPos.z, r1, c6                  ; oPos.z = d <.> world_3
        dp4 oPos.w, r1, c7                  ; oPos.w = d <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        device.SetVertexShaderConstant(0, 
                                       new float[]{0.0f,15.0f,1.0f,3.0f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.6f,1.0f,0.0f,0.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,0.274574f,1.43644f,0.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{-0.218218f,-0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(4, new Vector4[]{world_1});
        device.SetVertexShaderConstant(5, new Vector4[]{world_2});
        device.SetVertexShaderConstant(6, new Vector4[]{world_3});
        device.SetVertexShaderConstant(7, new Vector4[]{world_4});
        device.SetVertexShaderConstant(8, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Plane", 125, 125, new Plane(), 
                        new VSlider[]
                        {
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
