// Vertex shader "PlaneTwist", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class PlaneTwist : VShader {
    // Vertex shader "PlaneTwist".  Uses 22 float temporaries, 49 float
    // constants, and 63 instructions.
    public PlaneTwist() : base(@"
        vs.1.1
        ; c0 = {3.14159, 0.63662, 0.5, 1.5708}
        ; c1 = {2.0, 4.0, 8.0, 1.0}
        ; c2 = {0.0, 1.0, 0.6, 15.0}
        ; c3 = {0.4, 1.0, 0.3, 0.0}
        ; c4 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c5 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, twistRate = c3.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, c3.w, v0.x                ; p_1 = twistRate * u
        mad r0.x, c0.y, r0.x, c0.z          ; p_0 = c_0.y * p_1 + c_0.z
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.x, r0.y, -c0.w         ; a = c_0.x * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c1.w                      ; d.x = c_1.w
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.y, c6, r2                    ; f = c_6 <.> p_1
        dp4 r0.z, c7, r1                    ; e = c_7 <.> d
        mul r0.w, r0.z, r0.z                ; p_2 = e * e
        mad r0.w, -r0.y, r0.y, r0.w         ; g = -f * f + p_2
        mul r2.x, c1.x, r0.y                ; p_0 = c_1.x * f
        mul r2.x, r2.x, r0.z                ; h = p_0 * e
        mov r2.zw, v0.y                     ; p_0.y = v, p_0.z = v
        mov r2.y, c1.y                      ; p_0.x = c_1.y
        mov r3.x, v0.x                      ; p_1.x = u
        mov r3.y, r0.w                      ; p_1.y = g
        mov r3.z, r2.x                      ; p_1.z = h
        mul r2.yzw, r2.wyzw, r3.zxyz        ; i = p_0 * p_1
        mov r3.x, c2.x                      ; j.x = c_2.x
        mov r3.y, r0.w                      ; j.y = g
        mov r3.z, r2.x                      ; j.z = h
        dp3 r3.w, r3.xyz, r3.xyz            ; p_0 = j <.> j
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r3.xyz, r3.w, r3.xyz            ; l = p_0.xxx * j
        mul r3.w, r0.y, r0.z                ; p_0 = f * e
        mul r3.w, r3.w, c3.w                ; p_1 = p_0 * twistRate
        mul r3.w, c1.z, r3.w                ; p_1 = c_1.z * p_1
        mul r4.y, -v0.y, r3.w               ; k.y = -v * p_1
        mov r3.w, c3.w                      ; p_1 = twistRate
        mul r3.w, c1.y, r3.w                ; p_1 = c_1.y * p_1
        mul r3.w, r0.w, r3.w                ; p_1 = g * p_1
        mul r4.z, v0.y, r3.w                ; k.z = v * p_1
        mov r4.x, c1.y                      ; k.x = c_1.y
        dp3 r3.w, r4.xyz, r4.xyz            ; p_0 = k <.> k
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r4.xyz, r3.w, r4.xyz            ; m = p_0.xxx * k
        mul r5.xyz, r4.yzx, r3.zxy          ; p_2 = m.yzx * l.zxy
        mad r3.xyz, -r3.yzx, r4.zxy, r5.xyz ; n = -l.yzx * m.zxy + p_2
        dp3 r3.w, r3.xyz, c4.xyz            ; o = n <.> c_4.xyz
        add r4.xyz, c12.xyz, -r2.yzw        ; p = eyePos - i
        dp3 r4.w, r4.xyz, r4.xyz            ; p_0 = p <.> p
        rsq r4.w, r4.w                      ; p_0 = rsq p_0
        mul r4.xyz, r4.w, r4.xyz            ; p_1 = p_0.xxx * p
        mul r4.w, c1.x, r3.w                ; p_0 = c_1.x * o
        mad r5.xyz, r4.w, r3.xyz, -c4.xyz   ; p_0 = p_0.xxx * n - c_4.xyz
        dp3 r4.x, r5.xyz, r4.xyz            ; p_1 = p_0 <.> p_1
        max r4.x, c2.x, r4.x                ; p_0 = max (c_2.x) p_1
        log r4.x, r4.x                      ; p_0 = log p_0
        mul r4.x, r4.x, c2.w                ; p_0 = p_0 * c_2.w
        exp r4.x, r4.x                      ; p_1 = exp p_0
        mad r5, c3.xxxy, r3.w, c3.zzzy      ; p_1 = c_3.xxxy * o.xxxx + c_3.zzzy
        mul r5, c2.xxy, r5                  ; p_2 = c_2.xxyy * p_1
        mad oD0, c2.zzzy, r4.x, r5          ; oD0 = c_2.zzzy * p_1.xxxx + p_2
        mov r3.w, c1.w                      ; q.w = c_1.w
        mov r3.xyz, r2.yzw                  ; q.x = i.x, q.y = i.y, q.z = i.z
        dp4 oPos.x, r3, c8                  ; oPos.x = q <.> world_1
        dp4 oPos.y, r3, c9                  ; oPos.y = q <.> world_2
        dp4 oPos.z, r3, c10                 ; oPos.z = q <.> world_3
        dp4 oPos.w, r3, c11                 ; oPos.w = q <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float twistRate = floats[0];
        device.SetVertexShaderConstant(0, 
                                       new float[]{3.14159f,0.63662f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,4.0f,8.0f,1.0f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,1.0f,0.6f,15.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,0.3f,twistRate});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(5, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,0.0f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("PlaneTwist", 125, 125, new PlaneTwist(), 
                        new VSlider[]
                        {
                          new VSlider("twistRate", 0.0f, 10.0f, 5.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
