// Vertex shader "Ripple", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Ripple : VShader {
    // Vertex shader "Ripple".  Uses 32 float temporaries, 50 float
    // constants, and 80 instructions.
    public Ripple() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {0.0, 2.0, 4.0, 6.28319}
        ; c2 = {15.0, 25.1327, 12.5664, 0.0}
        ; c3 = {0.4, 1.0, 0.3, 0.6}
        ; c4 = {1.0, 0.0, 0.0, 0.0}
        ; c5 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, frequency = c2.w, magnitude = c4.z, phase = c4.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, c4.w, v0.x                ; p_1 = phase + u
        mov r1, c0                          ; p_2 = c_0
        mad r0.x, c2.w, r0.x, r1.z          ; p_0 = frequency * p_1 + p_2.z
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.y, r0.y, -c0.w         ; a = c_0.y * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.y, c6, r2                    ; f = c_6 <.> p_1
        dp4 r0.z, c7, r1                    ; e = c_7 <.> d
        add r0.w, -v0.y, c0.z               ; p_0 = -v + c_0.z
        expp r2, r0.w                       ; p_1 = expp p_0
        mad r0.w, c0.y, r2.y, -c0.w         ; g = c_0.y * p_1.y - c_0.w
        mul r2.x, c1.y, r0.y                ; p_0 = c_1.y * f
        mul r2.x, r2.x, r0.z                ; p_1 = p_0 * e
        mul r2.x, c4.z, r2.x                ; i = magnitude * p_1
        add r2.y, -v0.x, c0.z               ; h = -u + c_0.z
        mul r2.z, r0.w, r0.w                ; j = g * g
        mul r2.w, r2.z, r2.z                ; k = j * j
        mul r3.w, r2.w, r2.z                ; l.w = k * j
        mov r3.x, c0.x                      ; l.x = c_0.x
        mov r3.yz, r2.xzw                   ; l.y = j, l.z = k
        mul r4, r0.w, r3                    ; p_1 = g.xxxx * l
        dp4 r2.z, c6, r4                    ; n = c_6 <.> p_1
        dp4 r2.w, c7, r3                    ; m = c_7 <.> l
        mul r4.x, r2.z, r2.w                ; o = n * m
        mul r4.y, r2.y, r4.x                ; p = h * o
        mul r4.z, r2.w, r2.w                ; p_2 = m * m
        mad r4.z, -r2.z, r2.z, r4.z         ; q = -n * n + p_2
        mul r4.w, c1.z, r4.y                ; r = c_1.z * p
        mul r5.x, r2.y, r4.z                ; s = h * q
        mul r5.y, c1.y, r5.x                ; t = c_1.y * s
        mul r6.x, c2.y, r4.y                ; w.x = c_2.y * p
        mul r6.y, -c2.z, r5.x               ; w.y = -c_2.z * s
        mov r6.z, c1.x                      ; w.z = c_1.x
        dp3 r5.z, r6.xyz, r6.xyz            ; p_0 = w <.> w
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r6.xyz, r5.z, r6.xyz            ; y = p_0.xxx * w
        mul r7.x, -c1.y, r4.z               ; x.x = -c_1.y * q
        mul r7.y, -c1.z, r4.x               ; x.y = -c_1.z * o
        mul r5.z, r0.z, r0.z                ; p_2 = e * e
        mad r5.z, -r0.y, r0.y, r5.z         ; p_0 = -f * f + p_2
        mov r5.w, c2.w                      ; p_1 = frequency
        mul r5.w, c1.w, r5.w                ; p_1 = c_1.w * p_1
        mul r5.z, r5.z, r5.w                ; p_1 = p_0 * p_1
        mul r7.z, -c4.z, r5.z               ; x.z = -magnitude * p_1
        dp3 r5.z, r7.xyz, r7.xyz            ; p_0 = x <.> x
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r7.xyz, r5.z, r7.xyz            ; z = p_0.xxx * x
        mul r8.xyz, r7.yzx, r6.zxy          ; p_2 = z.yzx * y.zxy
        mad r6.xyz, -r6.yzx, r7.zxy, r8.xyz ; aa = -y.yzx * z.zxy + p_2
        dp3 r5.z, r6.xyz, c5.xyz            ; ba = aa <.> c_5.xyz
        mov r7.y, r4.w                      ; p_1.y = r
        mov r7.x, r5.y                      ; p_1.x = t
        mov r7.z, -r2.x                     ; p_1.z = -i
        add r7.xyz, c12.xyz, -r7.xyz        ; ca = eyePos - p_1
        dp3 r5.w, r7.xyz, r7.xyz            ; p_0 = ca <.> ca
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r7.xyz, r5.w, r7.xyz            ; p_1 = p_0.xxx * ca
        mul r5.w, c1.y, r5.z                ; p_0 = c_1.y * ba
        mad r8.xyz, r5.w, r6.xyz, -c5.xyz   ; p_0 = p_0.xxx * aa - c_5.xyz
        dp3 r5.w, r8.xyz, r7.xyz            ; p_1 = p_0 <.> p_1
        max r5.w, c1.x, r5.w                ; p_0 = max (c_1.x) p_1
        log r5.w, r5.w                      ; p_0 = log p_0
        mul r5.w, r5.w, c2.x                ; p_0 = p_0 * c_2.x
        exp r5.w, r5.w                      ; p_1 = exp p_0
        mad r7, c3.xxxy, r5.z, c3.zzzy      ; p_1 = c_3.xxxy * ba.xxxx + c_3.zzzy
        mul r7, c4.xxyx, r7                 ; p_2 = c_4.xxyx * p_1
        mad oD0, c3.wwwy, r5.w, r7          ; oD0 = c_3.wwwy * p_1.xxxx + p_2
        mov r6.w, c0.x                      ; da.w = c_0.x
        mov r6.y, r4.w                      ; da.y = r
        mov r6.x, r5.y                      ; da.x = t
        mov r6.z, -r2.x                     ; da.z = -i
        dp4 oPos.x, r6, c8                  ; oPos.x = da <.> world_1
        dp4 oPos.y, r6, c9                  ; oPos.y = da <.> world_2
        dp4 oPos.z, r6, c10                 ; oPos.z = da <.> world_3
        dp4 oPos.w, r6, c11                 ; oPos.w = da <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float frequency = floats[0];
        float magnitude = floats[1];
        float phase = floats[2];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.0f,2.0f,4.0f,6.28319f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{15.0f,25.1327f,12.5664f,frequency});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{1.0f,0.0f,magnitude,phase});
        device.SetVertexShaderConstant(5, 
                                       new float[]{0.218218f,0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Ripple", 125, 125, new Ripple(), 
                        new VSlider[]
                        {
                          new VSlider("frequency", 0.0f, 10.0f, 3.0f),
                          new VSlider("magnitude", 0.0f, 1.0f, 0.08f),
                          new VSlider("phase", -0.5f, 0.5f, 0.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
