// Vertex shader "RippleH", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class RippleH : VShader {
    // Vertex shader "RippleH".  Uses 24 float temporaries, 47 float
    // constants, and 73 instructions.
    public RippleH() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {0.0, 2.0, 3.5, 12.5664}
        ; c2 = {0.1, 1.0, 0.6, 15.0}
        ; c3 = {1.0, 0.0, 0.4, 0.0}
        ; c4 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c5 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c6 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c7, world_2 = c8, world_3 = c9, world_4 = c10, eyePos = c11.xyz, frequency = c3.w, magnitude = c4.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r0.x, v0.x, v0.x                ; p_2 = u * u
        mad r0.x, v0.y, v0.y, r0.x          ; a = v * v + p_2
        rsq r0.y, r0.x                      ; b = rsq a
        rcp r0.z, c3.w                      ; p_0 = rcp frequency
        mul r0.z, r0.z, r0.y                ; p_0 = p_0 * b
        rcp r0.z, r0.z                      ; p_0 = rcp p_0
        add r0.z, r0.z, c0.z                ; p_0 = p_0 + c_0.z
        expp r1, r0.z                       ; p_1 = expp p_0
        mad r0.z, c0.y, r1.y, -c0.w         ; c = c_0.y * p_1.y - c_0.w
        mul r0.w, r0.z, r0.z                ; d = c * c
        mul r2.x, r0.w, r0.w                ; e = d * d
        mul r1.w, r2.x, r0.w                ; f.w = e * d
        mov r1.x, c0.x                      ; f.x = c_0.x
        mov r1.y, r0.w                      ; f.y = d
        mov r1.z, r2.x                      ; f.z = e
        mul r2, r0.z, r1                    ; p_1 = c.xxxx * f
        dp4 r0.w, c5, r2                    ; h = c_5 <.> p_1
        dp4 r2.x, c6, r1                    ; g = c_6 <.> f
        mul r2.w, c1.y, r0.w                ; p_0 = c_1.y * h
        mul r2.w, r2.w, r2.x                ; p_1.z = p_0 * g
        mov r2.yz, v0.xxy                   ; p_1.x = u, p_1.y = v
        mov r3.xy, c1.z                     ; p_0.x = c_1.z, p_0.y = c_1.z
        mov r3.z, c4.w                      ; p_0.z = magnitude
        mul r2.yzw, r3.zxyz, r2.wyzw        ; i = p_0 * p_1
        mul r3.x, r2.x, r2.x                ; p_2 = g * g
        mad r3.x, -r0.w, r0.w, r3.x         ; j = -h * h + p_2
        mul r3.y, c1.y, r0.x                ; p_0 = c_1.y * a
        rcp r3.y, r3.y                      ; k = rcp p_0
        mul r3.z, c3.w, r0.x                ; l = frequency * a
        mul r3.w, v0.y, r0.y                ; p_0 = v * b
        mul r3.w, r3.w, r3.y                ; p_0 = p_0 * k
        mul r3.w, r3.w, r3.z                ; p_1 = p_0 * l
        mul r3.w, c1.w, r3.w                ; p_1 = c_1.w * p_1
        mul r3.w, r3.x, r3.w                ; p_1 = j * p_1
        mul r4.z, c4.w, r3.w                ; m.z = magnitude * p_1
        mov r4.xy, c1.xz                    ; m.x = c_1.x, m.y = c_1.z
        dp3 r3.w, r4.xyz, r4.xyz            ; p_0 = m <.> m
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r4.xyz, r3.w, r4.xyz            ; o = p_0.xxx * m
        mul r3.w, v0.x, r0.y                ; p_0 = u * b
        mul r3.w, r3.w, r3.y                ; p_0 = p_0 * k
        mul r3.w, r3.w, r3.z                ; p_1 = p_0 * l
        mul r3.w, c1.w, r3.w                ; p_1 = c_1.w * p_1
        mul r3.w, r3.x, r3.w                ; p_1 = j * p_1
        mul r5.z, c4.w, r3.w                ; n.z = magnitude * p_1
        mov r5.xy, c1.zx                    ; n.x = c_1.z, n.y = c_1.x
        dp3 r3.w, r5.xyz, r5.xyz            ; p_0 = n <.> n
        rsq r3.w, r3.w                      ; p_0 = rsq p_0
        mul r5.xyz, r3.w, r5.xyz            ; p = p_0.xxx * n
        mul r6.xyz, r5.yzx, r4.zxy          ; p_2 = p.yzx * o.zxy
        mad r3.xyz, -r4.yzx, r5.zxy, r6.xyz ; q = -o.yzx * p.zxy + p_2
        dp3 r3.w, r3.xyz, c4.xyz            ; r = q <.> c_4.xyz
        add r4.xyz, c11.xyz, -r2.yzw        ; s = eyePos - i
        dp3 r4.w, r4.xyz, r4.xyz            ; p_0 = s <.> s
        rsq r4.w, r4.w                      ; p_0 = rsq p_0
        mul r4.xyz, r4.w, r4.xyz            ; p_1 = p_0.xxx * s
        mul r4.w, c1.y, r3.w                ; p_0 = c_1.y * r
        mad r5.xyz, r4.w, r3.xyz, -c4.xyz   ; p_0 = p_0.xxx * q - c_4.xyz
        dp3 r4.x, r5.xyz, r4.xyz            ; p_1 = p_0 <.> p_1
        max r4.x, c1.x, r4.x                ; p_0 = max (c_1.x) p_1
        log r4.x, r4.x                      ; p_0 = log p_0
        mul r4.x, r4.x, c2.w                ; p_0 = p_0 * c_2.w
        exp r4.x, r4.x                      ; p_1 = exp p_0
        mov r5, c2                          ; p_2 = c_2
        mad r5, c3.zzzx, r3.w, r5.xxxy      ; p_1 = c_3.zzzx * r.xxxx + p_2.xxxy
        mul r5, c3.xxyx, r5                 ; p_2 = c_3.xxyx * p_1
        mad oD0, c2.zzzy, r4.x, r5          ; oD0 = c_2.zzzy * p_1.xxxx + p_2
        mov r3.w, c0.x                      ; t.w = c_0.x
        mov r3.xyz, r2.yzw                  ; t.x = i.x, t.y = i.y, t.z = i.z
        dp4 oPos.x, r3, c7                  ; oPos.x = t <.> world_1
        dp4 oPos.y, r3, c8                  ; oPos.y = t <.> world_2
        dp4 oPos.z, r3, c9                  ; oPos.z = t <.> world_3
        dp4 oPos.w, r3, c10                 ; oPos.w = t <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float frequency = floats[0];
        float magnitude = floats[1];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.0f,2.0f,3.5f,12.5664f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.1f,1.0f,0.6f,15.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{1.0f,0.0f,0.4f,frequency});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,0.872872f,0.436436f,magnitude});
        device.SetVertexShaderConstant(5, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(7, new Vector4[]{world_1});
        device.SetVertexShaderConstant(8, new Vector4[]{world_2});
        device.SetVertexShaderConstant(9, new Vector4[]{world_3});
        device.SetVertexShaderConstant(10, new Vector4[]{world_4});
        device.SetVertexShaderConstant(11, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("RippleH", 125, 125, new RippleH(), 
                        new VSlider[]
                        {
                          new VSlider("frequency", 0.0f, 10.0f, 5.0f),
                          new VSlider("magnitude", 0.0f, 1.0f, 0.1f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
