// Vertex shader "RippleTextured", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class RippleTextured : VShader {
    // Vertex shader "RippleTextured".  Uses 36 float temporaries, 52 float
    // constants, and 88 instructions.
    public RippleTextured() : base(@"
        vs.1.1
        ; c0 = {0.5, 1.0, 3.14159, 1.5708}
        ; c1 = {0.0, 2.0, 4.0, 6.28319}
        ; c2 = {7.0, 15.0, 25.1327, 12.5664}
        ; c3 = {0.4, 1.0, 0.3, 0.6}
        ; c4 = {1.0, -1.0, 0.0, 0.0}
        ; c5 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, frequency = c4.w, magnitude = c5.w, phase = c12.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, c12.w, v0.x               ; p_1 = phase + u
        mov r1, c0                          ; p_2 = c_0
        mad r0.x, c4.w, r0.x, r1.x          ; p_0 = frequency * p_1 + p_2.x
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.z, r0.y, -c0.w         ; a = c_0.z * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.y                      ; d.x = c_0.y
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        add r0.y, -v0.y, c0.x               ; p_0 = -v + c_0.x
        expp r2, r0.y                       ; p_1 = expp p_0
        mad r0.y, c0.z, r2.y, -c0.w         ; e = c_0.z * p_1.y - c_0.w
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.z, c6, r2                    ; g = c_6 <.> p_1
        dp4 r0.w, c7, r1                    ; f = c_7 <.> d
        mul r3.x, r0.y, r0.y                ; h = e * e
        mul r3.y, r3.x, r3.x                ; i = h * h
        mul r2.w, r3.y, r3.x                ; j.w = i * h
        mov r2.x, c0.y                      ; j.x = c_0.y
        mov r2.yz, r3.xxy                   ; j.y = h, j.z = i
        mul r3, r0.y, r2                    ; p_1 = e.xxxx * j
        dp4 r3.x, c6, r3                    ; l = c_6 <.> p_1
        dp4 r3.y, c7, r2                    ; k = c_7 <.> j
        mul r3.z, r3.y, r3.y                ; p_2 = k * k
        mad r3.z, -r3.x, r3.x, r3.z         ; n = -l * l + p_2
        add r3.w, -v0.x, c0.x               ; m = -u + c_0.x
        mul r4.x, r3.x, r3.y                ; o = l * k
        mul r4.y, c1.y, r0.z                ; p_0 = c_1.y * g
        mul r4.y, r4.y, r0.w                ; p_1 = p_0 * f
        mul r4.y, c5.w, r4.y                ; p = magnitude * p_1
        mul r4.z, r3.w, r4.x                ; q = m * o
        mul r4.w, r3.w, r3.z                ; r = m * n
        mul r5.x, c1.y, r4.w                ; s = c_1.y * r
        mul r5.y, c1.z, r4.z                ; t = c_1.z * q
        mul r6.x, c2.z, r4.z                ; w.x = c_2.z * q
        mul r6.y, -c2.w, r4.w               ; w.y = -c_2.w * r
        mov r6.z, c1.x                      ; w.z = c_1.x
        dp3 r5.z, r6.xyz, r6.xyz            ; p_0 = w <.> w
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r6.xyz, r5.z, r6.xyz            ; y = p_0.xxx * w
        mul r7.x, -c1.y, r3.z               ; x.x = -c_1.y * n
        mul r7.y, -c1.z, r4.x               ; x.y = -c_1.z * o
        mul r5.z, r0.w, r0.w                ; p_2 = f * f
        mad r5.z, -r0.z, r0.z, r5.z         ; p_0 = -g * g + p_2
        mov r5.w, c4.w                      ; p_1 = frequency
        mul r5.w, c1.w, r5.w                ; p_1 = c_1.w * p_1
        mul r5.z, r5.z, r5.w                ; p_1 = p_0 * p_1
        mul r7.z, -c5.w, r5.z               ; x.z = -magnitude * p_1
        dp3 r5.z, r7.xyz, r7.xyz            ; p_0 = x <.> x
        rsq r5.z, r5.z                      ; p_0 = rsq p_0
        mul r7.xyz, r5.z, r7.xyz            ; z = p_0.xxx * x
        mul r8.xyz, r7.yzx, r6.zxy          ; p_2 = z.yzx * y.zxy
        mad r6.xyz, -r6.yzx, r7.zxy, r8.xyz ; aa = -y.yzx * z.zxy + p_2
        dp3 r5.z, r6.xyz, c5.xyz            ; ba = aa <.> c_5.xyz
        mul r5.w, c2.x, v0.x                ; p_0 = c_2.x * u
        expp r7, r5.w                       ; p_1 = expp p_0
        sge r5.w, c0.x, r7.y                ; ca = c_0.x >= p_1.y
        mul r6.w, c2.x, v0.y                ; p_0 = c_2.x * v
        expp r7, r6.w                       ; p_1 = expp p_0
        sge r6.w, c0.x, r7.y                ; da = c_0.x >= p_1.y
        sge r7.x, r5.w, r6.w                ; p_0 = ca >= da
        sge r7.y, r6.w, r5.w                ; p_1 = da >= ca
        min r5.w, r7.x, r7.y                ; p_0 = min p_0 p_1
        mad r7, r5.w, c4.xxyz, c4.zzx       ; p_0 = p_0.xxxx * c_4.xxyz + c_4.zzxx
        mad r8, c3.xxxy, r5.z, c3.zzzy      ; p_1 = c_3.xxxy * ba.xxxx + c_3.zzzy
        mul r7, r7, r8                      ; p_2 = p_0 * p_1
        mov r8.xy, r5.xy                    ; p_1.x = s, p_1.y = t
        mov r8.z, -r4.y                     ; p_1.z = -p
        add r8.xyz, c12.xyz, -r8.xyz        ; ea = eyePos - p_1
        dp3 r5.w, r8.xyz, r8.xyz            ; p_0 = ea <.> ea
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r8.xyz, r5.w, r8.xyz            ; p_1 = p_0.xxx * ea
        mul r5.w, c1.y, r5.z                ; p_0 = c_1.y * ba
        mad r9.xyz, r5.w, r6.xyz, -c5.xyz   ; p_0 = p_0.xxx * aa - c_5.xyz
        dp3 r5.w, r9.xyz, r8.xyz            ; p_1 = p_0 <.> p_1
        max r5.w, c1.x, r5.w                ; p_0 = max (c_1.x) p_1
        log r5.w, r5.w                      ; p_0 = log p_0
        mul r5.w, r5.w, c2.y                ; p_0 = p_0 * c_2.y
        exp r5.w, r5.w                      ; p_1 = exp p_0
        mad oD0, c3.wwwy, r5.w, r7          ; oD0 = c_3.wwwy * p_1.xxxx + p_2
        mov r6.w, c0.y                      ; fa.w = c_0.y
        mov r6.xy, r5.xy                    ; fa.x = s, fa.y = t
        mov r6.z, -r4.y                     ; fa.z = -p
        dp4 oPos.x, r6, c8                  ; oPos.x = fa <.> world_1
        dp4 oPos.y, r6, c9                  ; oPos.y = fa <.> world_2
        dp4 oPos.z, r6, c10                 ; oPos.z = fa <.> world_3
        dp4 oPos.w, r6, c11                 ; oPos.w = fa <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float frequency = floats[0];
        float magnitude = floats[1];
        float phase = floats[2];
        device.SetVertexShaderConstant(0, 
                                       new float[]{0.5f,1.0f,3.14159f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.0f,2.0f,4.0f,6.28319f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{7.0f,15.0f,25.1327f,12.5664f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{1.0f,-1.0f,0.0f,frequency});
        device.SetVertexShaderConstant(5, 
                                       new float[]{0.218218f,0.872872f,0.436436f,magnitude});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,phase});
    }
    public static Form MakeDemo()
    {
        return new Demo("RippleTextured", 125, 125, new RippleTextured(), 
                        new VSlider[]
                        {
                          new VSlider("frequency", 0.0f, 10.0f, 1.5f),
                          new VSlider("magnitude", 0.0f, 1.0f, 0.1f),
                          new VSlider("phase", -0.5f, 0.5f, 0.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
