// Vertex shader "Sphere", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Sphere : VShader {
    // Vertex shader "Sphere".  Uses 30 float temporaries, 54 float
    // constants, and 78 instructions.
    public Sphere() : base(@"
        vs.1.1
        ; c0 = {1.0, 2.4674, 6.08807, 15.0217}
        ; c1 = {2.0, 3.14159, 0.5, 1.5708}
        ; c2 = {0.0, 2.2, 6.9115, 4.0}
        ; c3 = {15.0, 27.646, 13.823, 0.0}
        ; c4 = {0.4, 1.0, 0.1, 0.6}
        ; c5 = {0.0, 1.0, 0.0, 0.0}
        ; c6 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c7 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c8 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c9 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c10, world_2 = c11, world_3 = c12, world_4 = c13, eyePos = c14.xyz
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mul r1.x, v0.x, v0.x                ; a = u * u
        mul r1.y, r1.x, r1.x                ; b = a * a
        mul r0.y, c0.y, r1.x                ; c.y = c_0.y * a
        mul r0.z, c0.z, r1.y                ; c.z = c_0.z * b
        mul r1.z, r1.y, r1.x                ; p_1 = b * a
        mul r0.w, c0.w, r1.z                ; c.w = c_0.w * p_1
        mov r0.x, c0.x                      ; c.x = c_0.x
        mul r1.x, c1.w, v0.x                ; p_0 = c_1.w * u
        mul r1, r1.x, r0                    ; p_1 = p_0.xxxx * c
        dp4 r1.x, c8, r1                    ; e = c_8 <.> p_1
        dp4 r1.y, c9, r0                    ; d = c_9 <.> c
        add r1.z, -v0.y, c1.z               ; p_0 = -v + c_1.z
        expp r2, r1.z                       ; p_1 = expp p_0
        mad r1.z, c1.y, r2.y, -c1.w         ; f = c_1.y * p_1.y - c_1.w
        mul r1.w, r1.y, r1.y                ; p_2 = d * d
        mad r1.w, -r1.x, r1.x, r1.w         ; g = -e * e + p_2
        mul r3.x, r1.z, r1.z                ; h = f * f
        mul r3.y, r3.x, r3.x                ; i = h * h
        mul r2.w, r3.y, r3.x                ; j.w = i * h
        mov r2.x, c0.x                      ; j.x = c_0.x
        mov r2.yz, r3.xxy                   ; j.y = h, j.z = i
        mul r3, r1.z, r2                    ; p_1 = f.xxxx * j
        dp4 r3.x, c8, r3                    ; m = c_8 <.> p_1
        mul r3.y, c1.x, r1.x                ; p_0 = c_1.x * e
        mul r3.y, r3.y, r1.y                ; k = p_0 * d
        dp4 r3.z, c9, r2                    ; l = c_9 <.> j
        mul r3.w, r3.z, r3.z                ; p_2 = l * l
        mad r3.w, -r3.x, r3.x, r3.w         ; n = -m * m + p_2
        mul r4.x, r1.w, r3.w                ; o = g * n
        mul r4.z, c1.x, r3.x                ; p_0 = c_1.x * m
        mul r4.z, r4.z, r3.z                ; p_1 = p_0 * l
        mul r4.z, r1.w, r4.z                ; p.y = g * p_1
        mov r4.w, r3.y                      ; p.z = k
        mov r4.y, r4.x                      ; p.x = o
        mul r5.x, r3.x, r3.z                ; q = m * l
        mul r5.y, r3.w, r3.y                ; p_1.x = n * k
        mul r5.z, r1.x, r1.y                ; p_1 = e * d
        mul r5.z, r5.x, r5.z                ; p_1 = q * p_1
        mul r5.z, c2.w, r5.z                ; p_1.y = c_2.w * p_1
        mov r5.w, r1.w                      ; p_1.z = g
        mov r6.z, c2.z                      ; p_0.z = c_2.z
        mov r6.xy, -c2.z                    ; p_0.x = -c_2.z, p_0.y = -c_2.z
        mul r5.yzw, r6.zxyz, r5.wyzw        ; s = p_0 * p_1
        dp3 r6.x, r5.yzw, r5.yzw            ; p_0 = s <.> s
        rsq r6.x, r6.x                      ; p_0 = rsq p_0
        mul r5.yzw, r6.x, r5.wyzw           ; w = p_0.xxx * s
        mul r6.x, r1.w, r5.x                ; p_1 = g * q
        mul r6.x, c3.y, r6.x                ; r.x = c_3.y * p_1
        mul r6.y, -c3.z, r4.x               ; r.y = -c_3.z * o
        mov r6.z, c2.x                      ; r.z = c_2.x
        dp3 r6.w, r6.xyz, r6.xyz            ; p_0 = r <.> r
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r6.xyz, r6.w, r6.xyz            ; t = p_0.xxx * r
        mul r7.xyz, r5.zwy, r6.zxy          ; p_2 = w.yzx * t.zxy
        mad r5.xyz, -r6.yzx, r5.wyz, r7.xyz ; x = -t.yzx * w.zxy + p_2
        dp3 r5.w, r5.xyz, c6.xyz            ; y = x <.> c_6.xyz
        mov r6.xyz, c14.xyz                 ; p_2 = eyePos
        mad r6.xyz, -c2.y, r4.yzw, r6.xyz   ; z = -c_2.yyy * p + p_2
        dp3 r6.w, r6.xyz, r6.xyz            ; p_0 = z <.> z
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r6.xyz, r6.w, r6.xyz            ; p_1 = p_0.xxx * z
        mul r6.w, c1.x, r5.w                ; p_0 = c_1.x * y
        mad r7.xyz, r6.w, r5.xyz, -c6.xyz   ; p_0 = p_0.xxx * x - c_6.xyz
        dp3 r6.x, r7.xyz, r6.xyz            ; p_1 = p_0 <.> p_1
        max r6.x, c2.x, r6.x                ; p_0 = max (c_2.x) p_1
        log r6.x, r6.x                      ; p_0 = log p_0
        mul r6.x, r6.x, c3.x                ; p_0 = p_0 * c_3.x
        exp r6.x, r6.x                      ; p_1 = exp p_0
        mad r7, c4.xxxy, r5.w, c4.zzzy      ; p_1 = c_4.xxxy * y.xxxx + c_4.zzzy
        mul r7, c5.xxy, r7                  ; p_2 = c_5.xxyy * p_1
        mad oD0, c4.wwwy, r6.x, r7          ; oD0 = c_4.wwwy * p_1.xxxx + p_2
        mul r6.xyz, c2.y, r4.yzw            ; aa = c_2.yyy * p
        mov r5.w, c0.x                      ; ba.w = c_0.x
        mov r5.xyz, r6.xyz                  ; ba.x = aa.x, ba.y = aa.y, ba.z = aa.z
        dp4 oPos.x, r5, c10                 ; oPos.x = ba <.> world_1
        dp4 oPos.y, r5, c11                 ; oPos.y = ba <.> world_2
        dp4 oPos.z, r5, c12                 ; oPos.z = ba <.> world_3
        dp4 oPos.w, r5, c13                 ; oPos.w = ba <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,2.4674f,6.08807f,15.0217f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,2.2f,6.9115f,4.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{15.0f,27.646f,13.823f,0.0f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.4f,1.0f,0.1f,0.6f});
        device.SetVertexShaderConstant(5, 
                                       new float[]{0.0f,1.0f,0.0f,0.0f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,0.0f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,0.0f});
        device.SetVertexShaderConstant(8, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(9, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(10, new Vector4[]{world_1});
        device.SetVertexShaderConstant(11, new Vector4[]{world_2});
        device.SetVertexShaderConstant(12, new Vector4[]{world_3});
        device.SetVertexShaderConstant(13, new Vector4[]{world_4});
        device.SetVertexShaderConstant(14, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Sphere", 125, 250, new Sphere(), 
                        new VSlider[]
                        {
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
