// Vertex shader "Torus", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class Torus : VShader {
    // Vertex shader "Torus".  Uses 30 float temporaries, 49 float
    // constants, and 88 instructions.
    public Torus() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {2.0, 12.5664, 6.28319, 25.1327}
        ; c2 = {0.0, 1.0, 0.6, 15.0}
        ; c3 = {0.4, 1.0, 0.3, 0.0}
        ; c4 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c5 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c6 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c7, world_2 = c8, world_3 = c9, world_4 = c10, eyePos = c11.xyz, sweepRad = c3.w, crossRad = c4.w, sweepFrac = c11.w, crossFrac = c12.x
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mov r0, c0                          ; p_2 = c_0
        mad r0.x, v0.x, c12.x, r0.z         ; p_0 = u * crossFrac + p_2.z
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.y, r0.y, -c0.w         ; a = c_0.y * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.y, c5, r2                    ; f = c_5 <.> p_1
        dp4 r0.z, c6, r1                    ; e = c_6 <.> d
        mov r2, c0                          ; p_2 = c_0
        mad r0.w, -v0.y, c11.w, r2.z        ; p_0 = -v * sweepFrac + p_2.z
        expp r2, r0.w                       ; p_1 = expp p_0
        mad r0.w, c0.y, r2.y, -c0.w         ; g = c_0.y * p_1.y - c_0.w
        mul r2.x, r0.z, r0.z                ; p_2 = e * e
        mad r2.x, -r0.y, r0.y, r2.x         ; h = -f * f + p_2
        mul r2.y, r0.w, r0.w                ; i = g * g
        mul r2.z, r2.y, r2.y                ; j = i * i
        mul r3.w, r2.z, r2.y                ; k.w = j * i
        mov r3.x, c0.x                      ; k.x = c_0.x
        mov r3.yz, r2.xyz                   ; k.y = i, k.z = j
        mul r4, r0.w, r3                    ; p_1 = g.xxxx * k
        dp4 r2.y, c5, r4                    ; m = c_5 <.> p_1
        dp4 r2.z, c6, r3                    ; l = c_6 <.> k
        mov r2.w, c3.w                      ; p_2 = sweepRad
        mad r2.w, c4.w, r2.x, r2.w          ; n = crossRad * h + p_2
        mul r4.x, r2.z, r2.z                ; p_2 = l * l
        mad r4.x, -r2.y, r2.y, r4.x         ; o = -m * m + p_2
        mul r4.z, c1.x, r2.y                ; p_0 = c_1.x * m
        mul r4.z, r4.z, r2.z                ; p_1.y = p_0 * l
        mul r4.w, c1.x, r0.y                ; p_0 = c_1.x * f
        mul r4.w, r4.w, r0.z                ; p_1.z = p_0 * e
        mov r4.y, r4.x                      ; p_1.x = o
        mov r5.z, c4.w                      ; p_0.z = crossRad
        mov r5.xy, r2.w                     ; p_0.x = n, p_0.y = n
        mul r4.yzw, r5.zxyz, r4.wyzw        ; p = p_0 * p_1
        mul r5.x, r2.y, r2.z                ; q = m * l
        mul r6.x, r0.y, r0.z                ; p_0 = f * e
        mul r6.x, r6.x, c12.x               ; s = p_0 * crossFrac
        mul r6.y, c1.y, r6.x                ; p_1 = c_1.y * s
        mul r6.y, c4.w, r6.y                ; p_1 = crossRad * p_1
        mul r5.y, -r4.x, r6.y               ; t.x = -o * p_1
        mul r6.y, c4.w, r6.x                ; p_1 = crossRad * s
        mul r6.y, r5.x, r6.y                ; p_1 = q * p_1
        mul r5.z, -c1.w, r6.y               ; t.y = -c_1.w * p_1
        mov r6.y, c12.x                     ; p_1 = crossFrac
        mul r6.y, c1.z, r6.y                ; p_1 = c_1.z * p_1
        mul r6.y, r2.x, r6.y                ; p_1 = h * p_1
        mul r5.w, c4.w, r6.y                ; t.z = crossRad * p_1
        dp3 r6.x, r5.yzw, r5.yzw            ; p_0 = t <.> t
        rsq r6.x, r6.x                      ; p_0 = rsq p_0
        mul r5.yzw, r6.x, r5.wyzw           ; x = p_0.xxx * t
        mul r6.x, r5.x, c11.w               ; p_1 = q * sweepFrac
        mul r6.x, -c1.y, r6.x               ; p_1 = -c_1.y * p_1
        mul r6.x, -r2.w, r6.x               ; r.x = -n * p_1
        mov r6.y, c11.w                     ; p_1 = sweepFrac
        mul r6.y, -c1.z, r6.y               ; p_1 = -c_1.z * p_1
        mul r6.y, r4.x, r6.y                ; p_1 = o * p_1
        mul r6.y, r2.w, r6.y                ; r.y = n * p_1
        mov r6.z, c2.x                      ; r.z = c_2.x
        dp3 r6.w, r6.xyz, r6.xyz            ; p_0 = r <.> r
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r6.xyz, r6.w, r6.xyz            ; w = p_0.xxx * r
        mul r7.xyz, r5.zwy, r6.zxy          ; p_2 = x.yzx * w.zxy
        mad r5.xyz, -r6.yzx, r5.wyz, r7.xyz ; y = -w.yzx * x.zxy + p_2
        dp3 r5.w, r5.xyz, c4.xyz            ; z = y <.> c_4.xyz
        add r6.xyz, c11.xyz, -r4.yzw        ; aa = eyePos - p
        dp3 r6.w, r6.xyz, r6.xyz            ; p_0 = aa <.> aa
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r6.xyz, r6.w, r6.xyz            ; p_1 = p_0.xxx * aa
        mul r6.w, c1.x, r5.w                ; p_0 = c_1.x * z
        mad r7.xyz, r6.w, r5.xyz, -c4.xyz   ; p_0 = p_0.xxx * y - c_4.xyz
        dp3 r6.x, r7.xyz, r6.xyz            ; p_1 = p_0 <.> p_1
        max r6.x, c2.x, r6.x                ; p_0 = max (c_2.x) p_1
        log r6.x, r6.x                      ; p_0 = log p_0
        mul r6.x, r6.x, c2.w                ; p_0 = p_0 * c_2.w
        exp r6.x, r6.x                      ; p_1 = exp p_0
        mad r7, c3.xxxy, r5.w, c3.zzzy      ; p_1 = c_3.xxxy * z.xxxx + c_3.zzzy
        mul r7, c2.xxy, r7                  ; p_2 = c_2.xxyy * p_1
        mad oD0, c2.zzzy, r6.x, r7          ; oD0 = c_2.zzzy * p_1.xxxx + p_2
        mov r5.w, c0.x                      ; ba.w = c_0.x
        mov r5.xyz, r4.yzw                  ; ba.x = p.x, ba.y = p.y, ba.z = p.z
        dp4 oPos.x, r5, c7                  ; oPos.x = ba <.> world_1
        dp4 oPos.y, r5, c8                  ; oPos.y = ba <.> world_2
        dp4 oPos.z, r5, c9                  ; oPos.z = ba <.> world_3
        dp4 oPos.w, r5, c10                 ; oPos.w = ba <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float sweepRad = floats[0];
        float crossRad = floats[1];
        float sweepFrac = floats[2];
        float crossFrac = floats[3];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,12.5664f,6.28319f,25.1327f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,1.0f,0.6f,15.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,0.3f,sweepRad});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,0.872872f,0.436436f,crossRad});
        device.SetVertexShaderConstant(5, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(7, new Vector4[]{world_1});
        device.SetVertexShaderConstant(8, new Vector4[]{world_2});
        device.SetVertexShaderConstant(9, new Vector4[]{world_3});
        device.SetVertexShaderConstant(10, new Vector4[]{world_4});
        device.SetVertexShaderConstant(11, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,sweepFrac});
        device.SetVertexShaderConstant(12, 
                                       new float[]{crossFrac,0.0f,0.0f,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("Torus", 125, 125, new Torus(), 
                        new VSlider[]
                        {
                          new VSlider("sweepRad", 0.0f, 3.0f, 1.5f),
                          new VSlider("crossRad", 0.0f, 3.0f, 0.5f),
                          new VSlider("sweepFrac", 0.0f, 1.0f, 1.0f),
                          new VSlider("crossFrac", 0.0f, 1.0f, 1.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
