// Vertex shader "TorusTextured", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class TorusTextured : VShader {
    // Vertex shader "TorusTextured".  Uses 34 float temporaries, 54 float
    // constants, and 100 instructions.
    public TorusTextured() : base(@"
        vs.1.1
        ; c0 = {0.5, 1.0, 3.14159, 1.5708}
        ; c1 = {2.0, 12.5664, 6.28319, 25.1327}
        ; c2 = {0.0, 1.0, 15.0, 20.0}
        ; c3 = {0.4, 1.0, 0.3, 0.6}
        ; c4 = {0.218218, 0.872872, 0.436436, 0.0}
        ; c5 = {1.0, -1.0, 0.0, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, sweepRad = c4.w, crossRad = c5.w, sweepFrac = c12.w, crossFrac = c13.x, circulate = c13.y
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        mov r0, c0                          ; p_2 = c_0
        mad r0.x, -v0.y, c12.w, r0.x        ; p_0 = -v * sweepFrac + p_2.x
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.z, r0.y, -c0.w         ; a = c_0.z * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.y                      ; d.x = c_0.y
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        add r0.y, c13.y, v0.x               ; p_0 = circulate + u
        mov r2, c0                          ; p_2 = c_0
        mad r0.y, r0.y, c13.x, r2.x         ; p_0 = p_0 * crossFrac + p_2.x
        expp r2, r0.y                       ; p_1 = expp p_0
        mad r0.y, c0.z, r2.y, -c0.w         ; e = c_0.z * p_1.y - c_0.w
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.z, c6, r2                    ; g = c_6 <.> p_1
        dp4 r0.w, c7, r1                    ; f = c_7 <.> d
        mul r3.x, r0.y, r0.y                ; h = e * e
        mul r3.y, r3.x, r3.x                ; i = h * h
        mul r2.w, r3.y, r3.x                ; j.w = i * h
        mov r2.x, c0.y                      ; j.x = c_0.y
        mov r2.yz, r3.xxy                   ; j.y = h, j.z = i
        mul r3, r0.y, r2                    ; p_1 = e.xxxx * j
        dp4 r3.x, c6, r3                    ; l = c_6 <.> p_1
        dp4 r3.y, c7, r2                    ; k = c_7 <.> j
        mul r3.z, r3.y, r3.y                ; p_2 = k * k
        mad r3.z, -r3.x, r3.x, r3.z         ; m = -l * l + p_2
        mul r3.w, r0.w, r0.w                ; p_2 = f * f
        mad r3.w, -r0.z, r0.z, r3.w         ; n = -g * g + p_2
        mov r4.x, c4.w                      ; p_2 = sweepRad
        mad r4.x, c5.w, r3.z, r4.x          ; o = crossRad * m + p_2
        mul r4.z, c1.x, r0.z                ; p_0 = c_1.x * g
        mul r4.z, r4.z, r0.w                ; p_1.y = p_0 * f
        mul r4.w, c1.x, r3.x                ; p_0 = c_1.x * l
        mul r4.w, r4.w, r3.y                ; p_1.z = p_0 * k
        mov r4.y, r3.w                      ; p_1.x = n
        mov r5.z, c5.w                      ; p_0.z = crossRad
        mov r5.xy, r4.x                     ; p_0.x = o, p_0.y = o
        mul r4.yzw, r5.zxyz, r4.wyzw        ; p = p_0 * p_1
        mul r5.x, r0.z, r0.w                ; q = g * f
        mul r6.x, r3.x, r3.y                ; p_0 = l * k
        mul r6.x, r6.x, c13.x               ; s = p_0 * crossFrac
        mul r6.y, c1.y, r6.x                ; p_1 = c_1.y * s
        mul r6.y, c5.w, r6.y                ; p_1 = crossRad * p_1
        mul r5.y, -r3.w, r6.y               ; t.x = -n * p_1
        mul r6.y, c5.w, r6.x                ; p_1 = crossRad * s
        mul r6.y, r5.x, r6.y                ; p_1 = q * p_1
        mul r5.z, -c1.w, r6.y               ; t.y = -c_1.w * p_1
        mov r6.y, c13.x                     ; p_1 = crossFrac
        mul r6.y, c1.z, r6.y                ; p_1 = c_1.z * p_1
        mul r6.y, r3.z, r6.y                ; p_1 = m * p_1
        mul r5.w, c5.w, r6.y                ; t.z = crossRad * p_1
        dp3 r6.x, r5.yzw, r5.yzw            ; p_0 = t <.> t
        rsq r6.x, r6.x                      ; p_0 = rsq p_0
        mul r5.yzw, r6.x, r5.wyzw           ; x = p_0.xxx * t
        mul r6.x, r5.x, c12.w               ; p_1 = q * sweepFrac
        mul r6.x, -c1.y, r6.x               ; p_1 = -c_1.y * p_1
        mul r6.x, -r4.x, r6.x               ; r.x = -o * p_1
        mov r6.y, c12.w                     ; p_1 = sweepFrac
        mul r6.y, -c1.z, r6.y               ; p_1 = -c_1.z * p_1
        mul r6.y, r3.w, r6.y                ; p_1 = n * p_1
        mul r6.y, r4.x, r6.y                ; r.y = o * p_1
        mov r6.z, c2.x                      ; r.z = c_2.x
        dp3 r6.w, r6.xyz, r6.xyz            ; p_0 = r <.> r
        rsq r6.w, r6.w                      ; p_0 = rsq p_0
        mul r6.xyz, r6.w, r6.xyz            ; w = p_0.xxx * r
        mul r7.xyz, r5.zwy, r6.zxy          ; p_2 = x.yzx * w.zxy
        mad r5.xyz, -r6.yzx, r5.wyz, r7.xyz ; y = -w.yzx * x.zxy + p_2
        dp3 r5.w, r5.xyz, c4.xyz            ; z = y <.> c_4.xyz
        mul r6.x, c2.z, v0.x                ; p_0 = c_2.z * u
        expp r6, r6.x                       ; p_1 = expp p_0
        sge r6.x, c0.x, r6.y                ; aa = c_0.x >= p_1.y
        mul r6.y, c2.w, v0.y                ; p_0 = c_2.w * v
        expp r7, r6.y                       ; p_1 = expp p_0
        sge r6.y, c0.x, r7.y                ; ba = c_0.x >= p_1.y
        sge r6.z, r6.x, r6.y                ; p_0 = aa >= ba
        sge r6.w, r6.y, r6.x                ; p_1 = ba >= aa
        min r6.x, r6.z, r6.w                ; p_0 = min p_0 p_1
        mov r7, c2                          ; p_2 = c_2
        mad r6, r6.x, c5.xxyz, r7.xxy       ; p_0 = p_0.xxxx * c_5.xxyz + p_2.xxyy
        mad r7, c3.xxxy, r5.w, c3.zzzy      ; p_1 = c_3.xxxy * z.xxxx + c_3.zzzy
        mul r6, r6, r7                      ; p_2 = p_0 * p_1
        add r7.xyz, c12.xyz, -r4.yzw        ; ca = eyePos - p
        dp3 r7.w, r7.xyz, r7.xyz            ; p_0 = ca <.> ca
        rsq r7.w, r7.w                      ; p_0 = rsq p_0
        mul r7.xyz, r7.w, r7.xyz            ; p_1 = p_0.xxx * ca
        mul r7.w, c1.x, r5.w                ; p_0 = c_1.x * z
        mad r8.xyz, r7.w, r5.xyz, -c4.xyz   ; p_0 = p_0.xxx * y - c_4.xyz
        dp3 r7.x, r8.xyz, r7.xyz            ; p_1 = p_0 <.> p_1
        max r7.x, c2.x, r7.x                ; p_0 = max (c_2.x) p_1
        log r7.x, r7.x                      ; p_0 = log p_0
        mul r7.x, r7.x, c2.z                ; p_0 = p_0 * c_2.z
        exp r7.x, r7.x                      ; p_1 = exp p_0
        mad oD0, c3.wwwy, r7.x, r6          ; oD0 = c_3.wwwy * p_1.xxxx + p_2
        mov r5.w, c0.y                      ; da.w = c_0.y
        mov r5.xyz, r4.yzw                  ; da.x = p.x, da.y = p.y, da.z = p.z
        dp4 oPos.x, r5, c8                  ; oPos.x = da <.> world_1
        dp4 oPos.y, r5, c9                  ; oPos.y = da <.> world_2
        dp4 oPos.z, r5, c10                 ; oPos.z = da <.> world_3
        dp4 oPos.w, r5, c11                 ; oPos.w = da <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float sweepRad = floats[0];
        float crossRad = floats[1];
        float sweepFrac = floats[2];
        float crossFrac = floats[3];
        float circulate = floats[4];
        device.SetVertexShaderConstant(0, 
                                       new float[]{0.5f,1.0f,3.14159f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{2.0f,12.5664f,6.28319f,25.1327f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.0f,1.0f,15.0f,20.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.4f,1.0f,0.3f,0.6f});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,0.872872f,0.436436f,sweepRad});
        device.SetVertexShaderConstant(5, 
                                       new float[]{1.0f,-1.0f,0.0f,crossRad});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,sweepFrac});
        device.SetVertexShaderConstant(13, 
                                       new float[]{crossFrac,circulate,0.0f,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("TorusTextured", 125, 125, new TorusTextured(), 
                        new VSlider[]
                        {
                          new VSlider("sweepRad", 0.0f, 3.0f, 1.2f),
                          new VSlider("crossRad", 0.0f, 3.0f, 1.0f),
                          new VSlider("sweepFrac", 0.0f, 1.0f, 1.0f),
                          new VSlider("crossFrac", 0.0f, 1.0f, 1.0f),
                          new VSlider("circulate", 0.0f, 2.0f, 0.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
