// Vertex shader "WavyCylinder", generated by Vertigo compiler.

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;

namespace Vertigo {

public class WavyCylinder : VShader {
    // Vertex shader "WavyCylinder".  Uses 29 float temporaries, 51 float
    // constants, and 84 instructions.
    public WavyCylinder() : base(@"
        vs.1.1
        ; c0 = {1.0, 3.14159, 0.5, 1.5708}
        ; c1 = {0.0, 2.0, 12.5664, 6.28319}
        ; c2 = {0.3, 1.0, 0.6, 15.0}
        ; c3 = {0.0, 1.0, 0.4, 0.0}
        ; c4 = {0.218218, -0.872872, 0.436436, 0.0}
        ; c5 = {-0.218218, 0.872872, -0.436436, 0.0}
        ; c6 = {1.0, -0.166667, 0.00833333, -0.000198413}
        ; c7 = {1.0, -0.5, 0.0416667, -0.00138889}
        ; uniform: world_1 = c8, world_2 = c9, world_3 = c10, world_4 = c11, eyePos = c12.xyz, frequency = c3.w, magnitude = c4.w, height = c5.w
        ; varying: u = v0.x, v = v0.y
        dcl_texcoord0 v0
        add r0.x, -v0.y, c0.z               ; p_0 = -v + c_0.z
        expp r0, r0.x                       ; p_1 = expp p_0
        mad r0.x, c0.y, r0.y, -c0.w         ; a = c_0.y * p_1.y - c_0.w
        mul r0.y, r0.x, r0.x                ; b = a * a
        mul r0.z, r0.y, r0.y                ; c = b * b
        mul r1.w, r0.z, r0.y                ; d.w = c * b
        mov r1.x, c0.x                      ; d.x = c_0.x
        mov r1.yz, r0.xyz                   ; d.y = b, d.z = c
        mov r2, c0                          ; p_2 = c_0
        mad r0.y, c3.w, v0.x, r2.z          ; p_0 = frequency * u + p_2.z
        expp r2, r0.y                       ; p_1 = expp p_0
        mad r0.y, c0.y, r2.y, -c0.w         ; e = c_0.y * p_1.y - c_0.w
        mul r2, r0.x, r1                    ; p_1 = a.xxxx * d
        dp4 r0.z, c6, r2                    ; g = c_6 <.> p_1
        dp4 r0.w, c7, r1                    ; f = c_7 <.> d
        mul r3.x, r0.y, r0.y                ; h = e * e
        mul r3.y, r3.x, r3.x                ; i = h * h
        mul r2.w, r3.y, r3.x                ; j.w = i * h
        mov r2.x, c0.x                      ; j.x = c_0.x
        mov r2.yz, r3.xxy                   ; j.y = h, j.z = i
        mul r3, r0.y, r2                    ; p_1 = e.xxxx * j
        dp4 r3.x, c6, r3                    ; l = c_6 <.> p_1
        dp4 r3.y, c7, r2                    ; k = c_7 <.> j
        mul r3.z, c1.y, r3.x                ; p_0 = c_1.y * l
        mul r3.z, r3.z, r3.y                ; p_1 = p_0 * k
        mov r4, c0                          ; p_2 = c_0
        mad r3.z, c4.w, r3.z, r4.x          ; n = magnitude * p_1 + p_2.x
        mul r3.w, r0.w, r0.w                ; p_2 = f * f
        mad r3.w, -r0.z, r0.z, r3.w         ; m = -g * g + p_2
        mul r4.y, c1.y, r0.z                ; p_0 = c_1.y * g
        mul r4.y, r4.y, r0.w                ; p_1.y = p_0 * f
        mov r4.z, v0.x                      ; p_1.z = u
        mov r4.x, r3.w                      ; p_1.x = m
        mov r5.z, c5.w                      ; p_0.z = height
        mov r5.xy, r3.z                     ; p_0.x = n, p_0.y = n
        mul r4.xyz, r5.xyz, r4.xyz          ; o = p_0 * p_1
        mul r4.w, r0.z, r0.w                ; p = g * f
        mul r5.w, r3.y, r3.y                ; p_2 = k * k
        mad r5.w, -r3.x, r3.x, r5.w         ; r = -l * l + p_2
        mov r6.x, c3.w                      ; p_1 = frequency
        mul r6.x, c1.w, r6.x                ; p_1 = c_1.w * p_1
        mul r6.x, r5.w, r6.x                ; p_1 = r * p_1
        mul r6.x, c4.w, r6.x                ; p_1 = magnitude * p_1
        mul r5.x, r3.w, r6.x                ; s.x = m * p_1
        mul r6.x, r5.w, c3.w                ; p_1 = r * frequency
        mul r6.x, c4.w, r6.x                ; p_1 = magnitude * p_1
        mul r6.x, r4.w, r6.x                ; p_1 = p * p_1
        mul r5.y, c1.z, r6.x                ; s.y = c_1.z * p_1
        mov r5.z, c5.w                      ; s.z = height
        dp3 r5.w, r5.xyz, r5.xyz            ; p_0 = s <.> s
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r5.xyz, r5.w, r5.xyz            ; w = p_0.xxx * s
        mul r5.w, c1.z, r4.w                ; p_1 = c_1.z * p
        mul r6.x, r3.z, r5.w                ; q.x = n * p_1
        mul r5.w, r3.w, -c1.w               ; p_1 = m * -c_1.w
        mul r6.y, r3.z, r5.w                ; q.y = n * p_1
        mov r6.z, c1.x                      ; q.z = c_1.x
        dp3 r5.w, r6.xyz, r6.xyz            ; p_0 = q <.> q
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r6.xyz, r5.w, r6.xyz            ; t = p_0.xxx * q
        mul r7.xyz, r5.yzx, r6.zxy          ; p_2 = w.yzx * t.zxy
        mad r5.xyz, -r6.yzx, r5.zxy, r7.xyz ; x = -t.yzx * w.zxy + p_2
        dp3 r4.w, r5.xyz, c4.xyz            ; y = x <.> c_4.xyz
        add r6.xyz, c12.xyz, -r4.xyz        ; z = eyePos - o
        dp3 r5.w, r6.xyz, r6.xyz            ; p_0 = z <.> z
        rsq r5.w, r5.w                      ; p_0 = rsq p_0
        mul r6.xyz, r5.w, r6.xyz            ; p_1 = p_0.xxx * z
        mul r5.w, c1.y, r4.w                ; p_0 = c_1.y * y
        mad r7.xyz, r5.w, r5.xyz, -c4.xyz   ; p_0 = p_0.xxx * x - c_4.xyz
        dp3 r5.w, r7.xyz, r6.xyz            ; p_1 = p_0 <.> p_1
        max r5.w, c1.x, r5.w                ; p_0 = max (c_1.x) p_1
        log r5.w, r5.w                      ; p_0 = log p_0
        mul r5.w, r5.w, c2.w                ; p_0 = p_0 * c_2.w
        exp r5.w, r5.w                      ; p_1 = exp p_0
        mov r6, c2                          ; p_2 = c_2
        mad r6, c3.zzzy, r4.w, r6.xxxy      ; p_1 = c_3.zzzy * y.xxxx + p_2.xxxy
        mul r6, c3.xyxy, r6                 ; p_2 = c_3.xyxy * p_1
        mad oD0, c2.zzzy, r5.w, r6          ; oD0 = c_2.zzzy * p_1.xxxx + p_2
        mov r5.w, c0.x                      ; aa.w = c_0.x
        mov r5.xyz, r4.xyz                  ; aa.x = o.x, aa.y = o.y, aa.z = o.z
        dp4 oPos.x, r5, c8                  ; oPos.x = aa <.> world_1
        dp4 oPos.y, r5, c9                  ; oPos.y = aa <.> world_2
        dp4 oPos.z, r5, c10                 ; oPos.z = aa <.> world_3
        dp4 oPos.w, r5, c11                 ; oPos.w = aa <.> world_4
    "){ }
    public override void SetConsts(Device device, 
                                   Vector4 world_1, 
                                   Vector4 world_2, 
                                   Vector4 world_3, 
                                   Vector4 world_4, 
                                   Vector3 eyePos, 
                                   float[] floats)
    {
        float frequency = floats[0];
        float magnitude = floats[1];
        float height = floats[2];
        device.SetVertexShaderConstant(0, 
                                       new float[]{1.0f,3.14159f,0.5f,1.5708f});
        device.SetVertexShaderConstant(1, 
                                       new float[]{0.0f,2.0f,12.5664f,6.28319f});
        device.SetVertexShaderConstant(2, 
                                       new float[]{0.3f,1.0f,0.6f,15.0f});
        device.SetVertexShaderConstant(3, 
                                       new float[]{0.0f,1.0f,0.4f,frequency});
        device.SetVertexShaderConstant(4, 
                                       new float[]{0.218218f,-0.872872f,0.436436f,magnitude});
        device.SetVertexShaderConstant(5, 
                                       new float[]{-0.218218f,0.872872f,-0.436436f,height});
        device.SetVertexShaderConstant(6, 
                                       new float[]{1.0f,-0.166667f,0.00833333f,-0.000198413f});
        device.SetVertexShaderConstant(7, 
                                       new float[]{1.0f,-0.5f,0.0416667f,-0.00138889f});
        device.SetVertexShaderConstant(8, new Vector4[]{world_1});
        device.SetVertexShaderConstant(9, new Vector4[]{world_2});
        device.SetVertexShaderConstant(10, new Vector4[]{world_3});
        device.SetVertexShaderConstant(11, new Vector4[]{world_4});
        device.SetVertexShaderConstant(12, 
                                       new float[]{eyePos.X,eyePos.Y,eyePos.Z,0.0f});
    }
    public static Form MakeDemo()
    {
        return new Demo("WavyCylinder", 125, 125, new WavyCylinder(), 
                        new VSlider[]
                        {
                          new VSlider("frequency", 0.0f, 8.0f, 3.0f),
                          new VSlider("magnitude", 0.0f, 1.0f, 0.15f),
                          new VSlider("height", 0.0f, 10.0f, 3.0f)
                        });
    }
    [STAThread]
    static void Main()
    {
        Application.Run(MakeDemo());
    }
}
}
